
if (SERVER) then

	AddCSLuaFile( "shared.lua" )
	SWEP.Weight				= 5
	SWEP.AutoSwitchTo		= false
	SWEP.AutoSwitchFrom		= false

end

if ( CLIENT ) then

	SWEP.DrawAmmo			= false
	SWEP.DrawCrosshair		= true
	SWEP.ViewModelFOV		= 65
	SWEP.ViewModelFlip		= false

end

SWEP.Author			= "Hentie"
SWEP.Contact		= ""
SWEP.Purpose		= ""
SWEP.Instructions	= ""

SWEP.Spawnable			= false
SWEP.AdminSpawnable		= false

SWEP.ViewModel			= "models/weapons/v_toolgun.mdl"
SWEP.WorldModel			= "models/weapons/w_toolgun.mdl"

SWEP.ShootSound			= Sound( "Airboat.FireGunRevDown" )
SWEP.Tool = {}
SWEP.Slot				= 5	
SWEP.SlotPos			= 6	

SWEP.Primary.Recoil			= 0
SWEP.Primary.Damage			= 0
SWEP.Primary.NumShots		= 0
SWEP.Primary.Cone			= 0
SWEP.Primary.Delay			= 0.5

SWEP.Primary.ClipSize		= -1
SWEP.Primary.DefaultClip	= -1
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo			= "none"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"

function SWEP:Initialize()
	//local temp = {}
	
	for k,v in pairs( self.Tool ) do
		v.SWEP = self
		v.Owner = self.Owner
		v.Weapon = self.Weapon
		function v:Instructions(str)
			if SERVER then
				local rp = RecipientFilter()
				rp:AddPlayer(self.SWEP.Owner)
				umsg.Start("toolinstruct", rp)
					umsg.String(tostring(str))
				umsg.End()
			else
				ToolInstruction = str
			end
		end
		self.Tool[k] = v
		self.Tool[k]:Initialize()
		self.Owner.CurTool = k
	end
	
	//self.Tool = temp
end

if CLIENT then
	ToolInstruction = ""
	usermessage.Hook("toolinstruct", function ( um ) ToolInstruction = um:ReadString() end)
end

function SWEP:Think()
	if SERVER then self.Owner:SetNWString("toolinstruct","HIHIHIHI") end
end

function SWEP:Deploy()
	if !self.Owner.CurTool then
		self.Owner.CurTool = "weld.lua"
	end
	self.Tool[self.Owner.CurTool]:Deploy()
	return true
end

function SWEP:Holster()
	self.Tool[self.Owner.CurTool]:Holster()
	self.Tool[self.Owner.CurTool].SWEP = self
	return true
end

function SWEP:PrimaryAttack()
	local tr = util.GetPlayerTrace( self.Owner )
	tr.mask = ( CONTENTS_SOLID|CONTENTS_MOVEABLE|CONTENTS_MONSTER|CONTENTS_WINDOW|CONTENTS_DEBRIS|CONTENTS_GRATE|CONTENTS_AUX )
	local trace = util.TraceLine( tr )
	if (!trace.Hit) then return end
	
	if SERVER then if !self.Tool[self.Owner.CurTool]:LeftClick(trace) then return end end
	self:DoShootEffect( trace.HitPos, trace.HitNormal, trace.Entity, trace.PhysicsBone )
end

function SWEP:DoShootEffect( hitpos, hitnormal, entity, physbone )
	self.Weapon:EmitSound( self.ShootSound	)
	self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK ) 	// View model animation
	
	local effectdata = EffectData()
		effectdata:SetOrigin( hitpos )
		effectdata:SetNormal( hitnormal )
		effectdata:SetEntity( entity )
		effectdata:SetAttachment( physbone )
	util.Effect( "selection_indicator", effectdata )	
	
	local effectdata = EffectData()
		effectdata:SetOrigin( hitpos )
		effectdata:SetStart( self.Owner:GetShootPos() )
		effectdata:SetAttachment( 1 )
		effectdata:SetEntity( self.Weapon )
	util.Effect( "ToolTracer", effectdata )
end

function SWEP:Custom()
	Msg("Custom")
end

function SWEP:DrawWeaponSelection( x, y, wide, tall, alpha )
	draw.SimpleText( "Tool Gun", "HUDSmall", x + wide/2, y + tall*0.2, Color( 255, 210, 0, 255 ), TEXT_ALIGN_CENTER )
end

function SWEP:DrawHUD()
	draw.SimpleText( ToolInstruction, "HUDSmall", 5, 73, Color( 255, 255, 255, 255 ) )
end

AddCSLuaFile( "cl_viewscreen.lua" )
function ToolObjCreate()
	local o = {}
	function o:LeftClick() return false end
	function o:Initialize() return false end
	function o:Instructions(str) end
	function o:Deploy() end
	function o:Holster() end
	o.Owner = nil
	o.Name = nil
	return o
end
local toolmodes = file.FindInLua( SWEP.Folder.."/stools/*.lua" )
for key, val in pairs( toolmodes ) do
	Msg(val)
	TOOL = ToolObjCreate()
	AddCSLuaFile( "stools/"..val )
	include( "stools/"..val )
	SWEP.Tool[ val ] = TOOL
	TOOL = nil
end

if (CLIENT) then
	include( "cl_viewscreen.lua" )
end