include("shared.lua")
--Round names.
--Developing new round system soon, this is faster currently.
hint = {}
hint.visible = false
hint.x = 0
hint.y = 0
hint.text = "nil"
FloodWeapons = {}

function GM:InitPostEntity()
	SpawnSheet = vgui.Create( "DPropertySheet" )
	//SpawnSheet:SetParent( DermaPanel )
	SpawnSheet:SetSize( 440, 400 )
	SpawnSheet:Center()
	SpawnSheet:SetVisible(false)
	
	SpawnForm = vgui.Create( "DPanel" )
	//SpawnForm:SetPos( 25, 50 )
	//SpawnForm:SetSize( 350, 350 )
	//SpawnForm:SetSpacing( 10 )
	//SpawnForm:SetName("")

	PropList = vgui.Create( "DPanelList", SpawnForm )
	PropList:SetPos( 5,5 )
	PropList:SetSize( 300, 359 )
	PropList:SetSpacing( 5 ) -- Spacing between items
	PropList:EnableHorizontal( false ) -- Only vertical items
	PropList:EnableVerticalScrollbar( true ) -- Allow scrollbar if you exceed the Y axis
 
	// Load Props
	PropCategory = {}
	PropCategoryContent = {}
	for k,v in ipairs(SETTINGS.Props) do
		if !v.blank then
			if !PropCategory[v.cat] then
				PropCategory[v.cat] = vgui.Create("DCollapsibleCategory", PropList)
				PropCategory[v.cat]:SetExpanded( true )
				PropCategory[v.cat]:SetLabel( v.cat )
				PropCategoryContent[v.cat] = vgui.Create( "DPanelList" )
				PropCategoryContent[v.cat]:EnableHorizontal(true)
				PropCategoryContent[v.cat]:SetAutoSize( true )
				PropCategoryContent[v.cat]:SetSpacing( 5 )
				PropCategoryContent[v.cat]:SetPadding( 5 )
				PropCategory[v.cat]:SetContents(PropCategoryContent[v.cat])
				PropList:AddItem(PropCategory[v.cat])
			end
			local PropButton = vgui.Create("SpawnIcon")
			PropButton:SetModel(Model(v.model))
			PropButton:SetToolTip("Model: " .. v.model .. "\nCost: " .. v.cost .. "\nHealth: " .. v.health)
			function PropButton:DoClick()
				RunConsoleCommand("spawnprop",k)
			end
			PropCategoryContent[v.cat]:AddItem(PropButton)
		end
	end
 
	ToolList = vgui.Create( "DPanelList", SpawnForm )
	ToolList:SetPos( 310,5 )
	ToolList:SetSize( 115, 359 )
	ToolList:SetSpacing( 5 ) -- Spacing between items
	ToolList:EnableHorizontal( false ) -- Only vertical items
	ToolList:EnableVerticalScrollbar( true ) -- Allow scrollbar if you exceed the Y axis
 
	// Load Tools
	for k,v in ipairs(SETTINGS.Tool) do
		if !v.blank then
			local tool = vgui.Create("DButton")
			tool:SetText(v.name)
			tool:SetToolTip(v.definition)
			function tool:DoClick()
				ToolList.selected = self
				RunConsoleCommand("choosetool",v.file)
			end
			tool.Paint = function(btn)
				if (ToolList.selected ~= btn) then
					if math.fmod(k,2) == 0 then
						surface.SetDrawColor(255,255,255,10)
					end
				else
					surface.SetDrawColor(50,150,255,250)
				end
				btn:DrawFilledRect()
			end
			ToolList:AddItem(tool)
		end
	end
 
	SpawnSheet:AddSheet( "Spawn Menu", SpawnForm, "gui/silkicons/brick_add", false, false, "Spawn props and choose tools." )
	
	WeaponsForm = vgui.Create( "DPanel" )
	
	WeaponsList = vgui.Create( "DPanelList", WeaponsForm )
	WeaponsList:SetPos( 5,5 )
	WeaponsList:SetSize( 420, 359 )
	WeaponsList:SetSpacing( 5 )
	WeaponsList:EnableHorizontal( false )
	WeaponsList:EnableVerticalScrollbar( true )
	WeaponCategory = {}
	WeaponCategoryContent = {}
 
	WeaponCategory[1] = vgui.Create("DCollapsibleCategory")
	WeaponCategory[1]:SetExpanded( true )
	WeaponCategory[1]:SetLabel( SETTINGS.PrimaryName )
	WeaponCategoryContent[1] = vgui.Create( "DPanelList" )
	WeaponCategoryContent[1]:EnableHorizontal(true)
	WeaponCategoryContent[1]:SetAutoSize( true )
	WeaponCategoryContent[1]:SetSpacing( 5 )
	WeaponCategoryContent[1]:SetPadding( 5 )
	WeaponCategory[1]:SetContents(WeaponCategoryContent[1])
	WeaponsList:AddItem(WeaponCategory[1])
	
	WeaponCategory[2] = vgui.Create("DCollapsibleCategory")
	WeaponCategory[2]:SetExpanded( true )
	WeaponCategory[2]:SetLabel( SETTINGS.SecondaryName )
	WeaponCategoryContent[2] = vgui.Create( "DPanelList" )
	WeaponCategoryContent[2]:EnableHorizontal(true)
	WeaponCategoryContent[2]:SetAutoSize( true )
	WeaponCategoryContent[2]:SetSpacing( 5 )
	WeaponCategoryContent[2]:SetPadding( 5 )
	WeaponCategory[2]:SetContents(WeaponCategoryContent[2])
	WeaponsList:AddItem(WeaponCategory[2])
	
	WeaponCategory[3] = vgui.Create("DCollapsibleCategory")
	WeaponCategory[3]:SetExpanded( true )
	WeaponCategory[3]:SetLabel( SETTINGS.TertiaryName )
	WeaponCategoryContent[3] = vgui.Create( "DPanelList" )
	WeaponCategoryContent[3]:EnableHorizontal(true)
	WeaponCategoryContent[3]:SetAutoSize( true )
	WeaponCategoryContent[3]:SetSpacing( 5 )
	WeaponCategoryContent[3]:SetPadding( 5 )
	WeaponCategory[3]:SetContents(WeaponCategoryContent[3])
	WeaponsList:AddItem(WeaponCategory[3])
	
	for k,v in ipairs(SETTINGS.Weapons) do
		if !v.blank then
			local WeaponButton = vgui.Create("SpawnIcon")
			WeaponButton:SetModel(Model(v.model))
			WeaponButton:SetToolTip(v.definition)
			function WeaponButton:DoClick()
				RunConsoleCommand("buygun",k)
			end
			WeaponCategoryContent[v.cat]:AddItem(WeaponButton)
		end
	end
	
	SpawnSheet:AddSheet( "Shop", WeaponsForm, "gui/silkicons/bomb", false, false, "Buy guns and weapons." )
	
	PPForm = vgui.Create( "DPanel" )
	
	SpawnSheet:AddSheet( "Buddies", PPForm, "gui/silkicons/user", false, false, "Allows other people to pick up your props." )
	
	InventoryForm = vgui.Create( "DPanel" )
	
	InventoryList = vgui.Create( "DPanelList", InventoryForm )
	InventoryList:SetPos( 5,5 )
	InventoryList:SetSize( 420, 359 )
	InventoryList:SetSpacing( 5 )
	InventoryList:EnableHorizontal( true )
	InventoryList:EnableVerticalScrollbar( true )
 
	SpawnSheet:AddSheet( "Inventory", InventoryForm, "gui/silkicons/application_view_tile", false, false, "Choose the weapons you want to use." )

	HelpForm = vgui.Create( "DPanel" )
	
	SpawnSheet:AddSheet( "Help", HelpForm, "gui/info", false, false, "Don't know how to play?" )
	
end

local function AddWeapon(um)
	Msg("AddWeapon")
	local k = um:ReadFloat()
	local gunid = um:ReadFloat()
	//FloodWeapons[k]=
	local form = vgui.Create("DPanel")
	form:SetSize(75,75)
	function form:Paint()
		draw.RoundedBox(3,0,0,73,73,Color(0,255,0,255))
		draw.RoundedBox(3,4,4,65,65,Color(46,46,46,255))
	end
	local FormButton = vgui.Create("SpawnIcon")
	FormButton:SetPos(5,5)
	FormButton:SetParent(form)
	FormButton:SetModel(Model(SETTINGS.Weapons[gunid].model))
	//FormButton:SetToolTip(SETTINGS.Weapons[gunid].definition)
	function FormButton:DoClick()
		//RunConsoleCommand("buygun",k)
	end
	InventoryList:AddItem(form)
end
usermessage.Hook("addweapon",AddWeapon)

// _Muffin's fonts.
surface.CreateFont( "coolvetica", 20, 500, true, false, "HUDSmall" )
surface.CreateFont( "coolvetica", 30, 500, true, false, "HUDMedium" )
surface.CreateFont( "coolvetica", 40, 500, true, false, "HUDLarge" )
surface.CreateFont( "coolvetica", 50, 500, true, false, "HUDHuge" )
local pasthealth = 100
local healthflash = 0
function GM:HUDPaint()
	if SETTINGS.round[GetGlobalInt("round")] then
		//surface.SetDrawColor( 0, 0, 0, 170) --Red
		//surface.DrawRect(0 , 0, ScrW(), 70 )
		draw.RoundedBox(8,ScrW()/2-150,ScrH()-40,300,48,Color(0,0,0,170))
		draw.SimpleText(string.Replace(SETTINGS.round[GetGlobalInt("round")].name,"%t",string.ToMinutesSeconds(GetGlobalInt("time")-CurTime())), "HUDSmall", ScrW() / 2, ScrH()-20, Color(255,255,255,255), TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
		if CurRound().drawhealth then
			if pasthealth ~= LocalPlayer():Health() then
				healthflash = 200
				pasthealth = LocalPlayer():Health()
			end
			if healthflash > 0 then
				healthflash = math.Clamp(healthflash - 3,0,healthflash)
			end
			draw.WordBox( 8, 5, ScrH()-100, SETTINGS.HealthName..": "..LocalPlayer():Health(), "HUDSmall", Color(255,healthflash,healthflash,255), Color(255,255,255,170) )
		end
		draw.WordBox( 8, 5, ScrH()-50, SETTINGS.MoneyName..": "..LocalPlayer():GetNWInt("Cash"), "HUDSmall", Color(0,255,0,255), Color(255,255,255,170) )
		local ent = LocalPlayer():GetEyeTrace().Entity
		if ent:IsValid() and !ent:IsWorld() and !ent:IsPlayer() then
			local health = ent:GetNWInt("Health")
			if health > 0 then
				draw.SimpleText(tostring(health), "HUDSmall", ScrW()/2, ScrH()/2-50, Color(255,0,0,255), TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
			end
		end
	else
		draw.WordBox( 8, ScrW()/2-170, ScrH()/2-50, "LOADING", "HUDHuge", Color(255,55,55,255), Color(255,255,255,170) )
	end
end

function GM:HUDShouldDraw(name)
	for k, v in pairs{"CHudHealth", "CHudBattery", "CHudAmmo", "CHudSecondaryAmmo", "CHUDCrosshair"} do 
		if name == v then return false end
	end
	return true
end

function GM:OnUndo(name)
	Msg(name)
end

function GM:OnSpawnMenuOpen()
	if SETTINGS.round[GetGlobalInt("round")] and SETTINGS.round[GetGlobalInt("round")].allowspawnmenu then
		RestoreCursorPosition()
		SpawnSheet:SetVisible(true)
		gui.EnableScreenClicker(true)
	end
end

function GM:OnSpawnMenuClose()
	RememberCursorPosition()
	SpawnSheet:SetVisible(false)
	gui.EnableScreenClicker(false)
end

function GM:ShowHelp()
	if LocalPlayer():Team() == TEAM_DEAD then
		--Create zombie classes window.
		local ch_classframe = vgui.Create("DFrame")
			ch_classframe:SetTitle("Choose a Class")
			ch_classframe:SetSize(200,300)
			ch_classframe:Center()
		local ch_classlist = vgui.Create( "DPanelList", ch_classframe )
			ch_classlist:SetPos( 2,25 )
			ch_classlist:SetSize( 196, 273 )
			ch_classlist:SetSpacing( 5 )
			ch_classlist:EnableHorizontal( false )
			ch_classlist:EnableVerticalScrollbar( true )
		for k,v in ipairs(self.ZOMBIES) do
			local zombiebutton = vgui.Create("DButton",ch_classlist)
				zombiebutton:SetText(v.name)
				zombiebutton:SetSize(100,30)
				zombiebutton.ZombieClass = k
				if v.round > GetGlobalInt("round") then
					zombiebutton:SetDisabled(true)
				end
				zombiebutton.DoClick = function( btn )
					hint.visible = false
					RunConsoleCommand("chooseclass",btn.ZombieClass)
					ch_classframe:Close()
				end
				zombiebutton.OnCursorEntered = function( btn )
					local x,y = ch_classframe:GetPos();
					hint.x = x
					hint.y = y+302
					hint.text = v.def
					hint.visible = true
				end
				zombiebutton.OnCursorExited = function( btn )
					hint.visible = false
				end
				ch_classlist:AddItem( zombiebutton )
		end
		ch_classframe:MakePopup()
	end
end
usermessage.Hook("ShowHelp", function() GAMEMODE:ShowHelp() end)
