AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
AddCSLuaFile("settings.lua")
include("shared.lua")
include("player.lua")
GM.CanZombieSpawn = false

-- The lazy man's function.

local function RemoveRagdollEntity( pl )

	if ( pl.m_hRagdollEntity && pl.m_hRagdollEntity:IsValid() ) then

		pl.m_hRagdollEntity:Remove()
		pl.m_hRagdollEntity = nil

	end

end

function GM:PlayerInitialSpawn( pl )
	pl:SetNWInt("Cash",5000)
	pl.Weapons = {}
end

function GM:PlayerDisconnected( pl )
end

function GM:PlayerDeath( pl, wep, killer)
	if CurRound().TimeToRespawn then
		pl.RespawnTime = CurRound().TimeToRespawn
	else
		-- Glare at yourself you sick /b/tard.
		pl.RespawnTime = 10
	end
	pl.NextDeathThink = 0
	--pl:SetTeam(TEAM_DEAD)
	if SETTINGS.ServerSideRagdolls then
		if ( pl.m_hRagdollEntity && pl.m_hRagdollEntity:IsValid() ) then

			pl:SpectateEntity( pl.m_hRagdollEntity )
			pl:Spectate( OBS_MODE_CHASE )

		end
	end
	timer.Simple(0.001,function()
		if CurRound().deathround then
			Msg("Deathround Start")
			local alive = 0
			for _,v in ipairs(player.GetAll()) do
				if v:Alive() then return end
			end
			self:ChangeRound(CurRound().deathround)
		end
	end)
end

function GM:PlayerDeathThink( pl )
	if GetGlobalInt("round") == 0 then
		pl:UnSpectate()
		pl.Weapons = {}
		pl:Spawn()
	end
	if pl.NextDeathThink < CurTime() then
		pl.RespawnTime = pl.RespawnTime - 1
		if pl.RespawnTime <= 0 then
			if CurRound().allowrespawn then
				pl:UnSpectate()
				pl:Spawn()
			else
				pl:Spectate( OBS_MODE_ROAMING )
			end
		end
		pl.NextDeathThink = CurTime() + 1
	end
end

function GM:PlayerSpawn( pl )
	pl:UnSpectate() -- Can't stop spamming this everywhere D:
	local cl_playermodel = pl:GetInfo( "cl_playermodel" )
	local cl_model = player_manager.TranslatePlayerModel( cl_playermodel )
	util.PrecacheModel( cl_model )
	pl:SetNWInt("PropDamage", 0)
	pl:SetModel( cl_model )
	RemoveRagdollEntity( pl )
	--pl:SetTeam(TEAM_HUMAN)
	pl:StripWeapons()
	pl:SetCanZoom(false)
	Msg(CurRound().name)
	Msg(CurRound().loadout)
	if CurRound().loadout then
		for _,weapon in ipairs(CurRound().loadout) do
			pl:Give(weapon)
		end
	end
end

function GM:PlayerShouldTakeDamage( pl, hitman )
	if CurRound().playertakedamage then
		if pl == hitman then
			return true
		end
		if hitman:IsPlayer() and pl:Team() == hitman:Team() and pl ~= hitman then
			return false
		end
		if (hitman:GetClass() == "trigger_hurt") then
			if SETTINGS.WaterDamageLevel <= pl:WaterLevel() then
				-- If atleast our feet are in the water and we are on a boat, then we're obviously not drowning.
				if pl:WaterLevel() == 1 and pl:OnGround() then return false end
				if SETTINGS.WaterDamageType == "RANDOM" then
					pl:TakeDamage(math.random(SETTINGS.WaterDamage[1],SETTINGS.WaterDamage[2]),pl)
					return false
				elseif SETTINGS.WaterDamageType == "DEFAULT" then
					return true
				end
			end
		end
	end
	return false
end

function GM:EntityTakeDamage( ent, inflictor, hitman, dmg, dmginfo )
	if !ent:IsPlayer() and dmginfo:GetDamageType() != 1 then -- If not player and is not physical damage.
		Msg(tostring(dmginfo:GetDamageType()).."\n")
		ent:SetHealth(9000)
		if CurRound().proptakedamage then
			if hitman:IsPlayer() then
				ent:SetNWInt("Health",ent:GetNWInt("Health")-math.ceil(dmg))
				if ent:GetNWInt("Health") <= 0 then
					ent:Fire("Break",0)
				end
			end
		end
	end
end

function GM:InitPostEntity()
	for _, v in pairs(ents.FindByName("water")) do
		v.OrigSpeed = v:GetKeyValues().speed
	end
	self:ChangeRound(1)
	self.NextTime = 0
end

function GM:Think()
	if self.NextTime < CurTime() then
		-- Lots of things to do. Wish it wasn't this way.
		if math.ceil(GetGlobalInt("time")-CurTime()) <= 0 then
			if GetGlobalInt("round") >= #SETTINGS.round then
				self:ChangeRound(1)
			else
				self:ChangeRound(GetGlobalInt("round")+1)
			end
		end
		if CurRound().unfreeze then
			for _,v in ipairs(ents.FindByClass("prop_physics")) do
				local entphys = v:GetPhysicsObject()
				if entphys:IsValid() then
					entphys:EnableMotion(true)
					entphys:Wake()
				end
			end
		end
		if CurRound().earnmoney then
			if SETTINGS.SurvivalTime > 0 then
				self.seconds = self.seconds + 1
			end
		end
		for k,v in ipairs(player.GetAll()) do
			if CurRound().earnmoney then
				if math.fmod(self.seconds,SETTINGS.SurvivalTime) == 0 then
					v:SetNWInt("Cash",v:GetNWInt("Cash")+SETTINGS.SurvivalMoney)
				end
			end
			if CurRound().antipiratepush then
					if !v:GetGroundEntity():IsWorld() and v:GetGroundEntity():IsValid() then
						if !v:CanUse(v:GetGroundEntity()) then
							local vel = -1 * v:GetVelocity()
							vel = vel + Vector(0, 0, 900) + Angle(0,math.random(1,360),0):Forward() * 900
							v:SetVelocity(vel)
							if (SETTINGS.antipiratedmg[1] > 0 and SETTINGS.antipiratedmg[2] > 0) then
								v:TakeDamage(math.random(SETTINGS.antipiratedmg[1],SETTINGS.antipiratedmg[2]),v)
							end
						end
					end
			end
		end
		if CurRound().waves and CurRound().waves != 0 and CurTime() > self.beginning+CurRound().waves then
			if self.waveson then
				for _, v in pairs(ents.FindByName("water")) do
					v:SetKeyValue("speed",50)
					v:Fire("Open","",0)
				end
				self.waveson = false
			else
				for _, v in pairs(ents.FindByName("water")) do
					v:SetKeyValue("speed",50) -- Instant gratification.
					v:Fire("Close","",0)
				end
				self.waveson = true
			end
		end
		self.NextTime = CurTime() + 1
	end
end

function GM:ChangeRound( rnd )
	SetGlobalInt("round",rnd)
	SetGlobalInt("time",CurTime()+CurRound().length)
	if CurRound().earnmoney then
		self.seconds = 0
	end
	if CurRound().waterrise then
		for _, v in ipairs(ents.FindByName("water")) do
			v:SetKeyValue("speed",v.OrigSpeed)
			v:Fire("Open","",0)
		end
		for _, v in ipairs(ents.FindByClass("prop_physics")) do
			v.origpos = v:GetPos()
			v.origang = v:GetAngles()
		end
	elseif CurRound().waterlower then
		for _, v in ipairs(ents.FindByName("water")) do
			v:SetKeyValue("speed",9999) -- Instant gratification.
			v:Fire("Close","",0)
		end
		for _, v in ipairs(ents.FindByClass("prop_physics")) do
			v:SetPos(v.origpos)
			v:SetAngles(v.origang)
			v:SetVelocity(Vector(0,0,0))
		end
	end
	for _,v in ipairs(player.GetAll()) do
		if SETTINGS.RemoveWeaponsEveryNewRound or CurRound().removeweapons or CurRound().ForceRespawn then
				v:StripWeapons()
		end
		if CurRound().ForceRespawn then v:Spawn() end
		if CurRound().ForceUp then v:SetVelocity(-1 * v:GetVelocity() + Vector(0,0,9999)) end
		if CurRound().giveguns then
			for _,gunid in ipairs(v.Weapons) do
				v:Give(SETTINGS.Weapons[gunid].id)
			end
		end
	end
	for _,v in ipairs(ents.GetAll()) do
		if v:GetClass() == "prop_physics" then
			if CurRound().removeunownedprops and !v:GetNWEntity("Owner"):IsValid() then
				v:Remove()
			end
		end
	end
	if CurRound().waves then
		self.beginning = CurTime()
	end
end

function GM:ShowHelp(pl)
	local rp = RecipientFilter()
	rp:AddPlayer(pl)
	umsg.Start("ShowHelp",rp)
	umsg.End()
end

concommand.Add( "buyweapon", function(pl,cmd,arg) GAMEMODE:ChangeClass(pl,arg[1]) end)

function GM:SpawnProp( pl, prop )
	if CurRound().allowspawnprop and prop and !prop.blank then
		if pl:GetNWInt("Cash") >= prop.cost then
			local ent = ents.Create( "prop_physics" )
			ent:SetModel(prop.model)
			ent:PhysicsInit( SOLID_VPHYSICS )
			ent:SetSolid( SOLID_VPHYSICS )
			ent:SetMoveType( MOVETYPE_VPHYSICS )
			local raise = ent:OBBCenter():Distance(ent:OBBMins())
			ent:SetPos(pl:GetEyeTrace().HitPos + Vector(0,0,(raise + 5)))
			ent:SetNWEntity("Owner", pl)
			ent:SetHealth(9000)
			ent:SetNWInt("Health", prop.health)
			ent.Prop = prop
			ent:Spawn()
			undo.Create("prop")
				undo.AddFunction( function() if ent:IsValid() then self:RefundProp(pl,ent) end end )
				undo.AddEntity(ent)
				undo.SetPlayer(pl)
			undo.Finish()
			pl:SetNWInt("Cash",pl:GetNWInt("Cash")-prop.cost)
		end
	end
end
concommand.Add( "spawnprop", function(pl,cmd,arg) GAMEMODE:SpawnProp(pl,SETTINGS.Props[tonumber(arg[1])]) end)

function GM:RefundProp(pl,ent)
	if ent:GetNWEntity("Owner") == pl then
		Msg("REFUND")
		local cash = 0
		if SETTINGS.PropResell == "HEALTH" then
			cash = ent:GetNWInt("Health")/ent.Prop.health*ent.Prop.cost
		elseif SETTINGS.PropResell == "CUSTOM" then
			cash = ent.Prop.resell
		elseif SETTINGS.PropResell == "FULL" then
			cash = ent.Prop.cost
		end
		pl:SetNWInt("Cash",pl:GetNWInt("Cash")+cash)
	end
end

function GM:ChangeClass( pl, class )
	--[[pl.ZombieClass = tonumber(class)
	if pl:Team() == TEAM_ZOMBIE and self.ZOMBIES[tonumber(class)] and self.CanZombieSpawn then
		pl:StripWeapons()
		pl:Spawn()
	end]]
end
concommand.Add( "chooseclass", function(pl,cmd,arg) GAMEMODE:ChangeClass(pl,arg[1]) end)

function GM:ChangeTool( pl, file )
	pl.CurTool = file
	pl:SelectWeapon("weapon_fl_tool")
	pl:GetWeapon("weapon_fl_tool"):Holster()
end
concommand.Add( "choosetool", function(pl,cmd,arg) GAMEMODE:ChangeTool(pl,arg[1]) end)

function GM:BuyGun( pl, gunid )
	local gun = SETTINGS.Weapons[gunid]
	if !table.HasValue(pl.Weapons,gunid) then
		if pl:GetNWInt("Cash") >= gun.cost then
			pl:SetNWInt("Cash",pl:GetNWInt("Cash")-gun.cost)
			local rp = RecipientFilter()
			rp:AddPlayer(pl)
			umsg.Start("addweapon",rp)
				umsg.Float(table.insert(pl.Weapons,gunid))
				umsg.Float(gunid)
			umsg.End()
		end
	end
end
concommand.Add( "buygun", function(pl,cmd,arg) GAMEMODE:BuyGun(pl,tonumber(arg[1])) end)

function GM:HandlePowerups( pl, powerup )
end

function GM:PhysgunPickup( pl, ent )
	return pl:CanUse(ent)
end

function GM:GravGunPunt( pl, ent )
	return pl:CanUse(ent)
end

function GM:GravGunOnPickedUp( pl, ent )
	return pl:CanUse(ent)
end

function GM:ShouldCollide ( enta, entb )
	if enta:IsPlayer() and entb:IsPlayer() then
		return false
	end
	return true
end

function GM:Move( pl, move )
	for k,v in ipairs(ents.FindInSphere( pl:GetPos(), 32 )) do
		if v:IsPlayer() and v != pl then
			pl:SetVelocity((v:GetPos()-pl:GetPos()):GetNormal()*-7)
		end
	end
	return move
end

local origundo = undo.Do_Undo
function undo.Do_Undo(Undo)
	if CurRound().allowundo then
		return origundo(Undo)
	end
end