if (SERVER) then
	AddCSLuaFile("shared.lua")
	SWEP.HoldType			= "gravgun"
end

if (CLIENT) then
	SWEP.PrintName			= "Super Gravity Gun"			
	SWEP.Author			= "LuaPineapple"
	SWEP.Slot			= 1
	SWEP.SlotPos			= 9
	SWEP.IconLetter			= "k"
end

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true
SWEP.ViewModel			= "models/weapons/v_superphyscannon.mdl"
SWEP.WorldModel			= "models/weapons/w_physics.mdl"
SWEP.Weight			= 50
SWEP.AutoSwitchTo		= true
SWEP.AutoSwitchFrom		= true
SWEP.DrawCrosshair		= true
SWEP.ViewModelFlip		= false
SWEP.Primary.ClipSize		= 100
SWEP.Primary.DefaultClip	= 0
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo		= "Gravity"
SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= true
SWEP.Secondary.Ammo		= ""
SWEP.HeldEnt				= 0
SWEP.HeldEntMass			= 0
SWEP.HackEnt				= 0
SWEP.Const					= 0
SWEP.Del			= CurTime()

util.PrecacheModel("models/props_junk/plasticbucket001a.mdl")
util.PrecacheModel("sprites/physbeam.spr")
util.PrecacheSound("weapons/physcannon/physcannon_charge.wav")
for i=1,4 do
	util.PrecacheSound("weapons/physcannon/superphys_launch"..i..".wav")
end
for i=1,3 do
	util.PrecacheSound("ambient/energy/zap"..i..".wav")
end

function SWEP:OwnerChanged()
	self.Weapon:EmitSound("weapons/physcannon/physcannon_charge.wav")
	self:ResetVars()
	self.Secondary.Automatic = true
end

function SWEP:ResetVars()
	self.HackEnt = 0 
	self.HeldEnt = 0
	self.HeldEntMass = 0
	self.Const = 0
end

function SWEP:Think()
	if self.HeldEnt == 0 or self.HackEnt == 0 then return end
	if (not self.HeldEnt:IsValid()) or (not self.HackEnt:IsValid()) then
		self:ResetVars()
		self.Secondary.Automatic = true
	end
	if SERVER then
		self.HackEnt:SetPos(self.Owner:GetShootPos()+self.Owner:GetAimVector()*75)
		self.HackEnt:PointAtEntity(self.Owner)
	end
	if math.random(1,25) < 3 then
		local e = EffectData()
		e:SetEntity(self.HeldEnt)
		e:SetMagnitude(30)
		e:SetScale(30)
		e:SetRadius(30)
		util.Effect("TeslaHitBoxes", e)
		self.HeldEnt:EmitSound("ambient/energy/zap"..math.random(1,3)..".wav")
	end
end

function SWEP:PrimaryAttack()
	if ( !self:CanPrimaryAttack() ) then return end
	self:TakePrimaryAmmo( 1 )
	self.Weapon:EmitSound("weapons/physcannon/superphys_launch"..math.random(1,4)..".wav")
	local trace = self.Owner:GetEyeTrace()
	if (SERVER) then
		if self.HeldEnt ~= 0 and self.HeldEnt:IsValid() then
			self:ForceLaunch()
			self.Weapon:SetNextPrimaryFire(CurTime() + 1)
			return
		end
		local rnd = math.random(1,99999)
		local TS = ents.Create("info_target")
		TS:SetPos((self.Owner:GetRight()*100)+(self.Owner:GetShootPos()+((self.Owner:GetAimVector()*50)+Vector(0,0,-100))))
		TS:SetName("TS"..rnd)
		local TE = ents.Create("info_target" )
		TE:SetPos(trace.HitPos)
		TE:SetName("TE"..rnd)
		local TB = ents.Create("env_beam")
		TB:SetKeyValue("texture", "sprites/physcannon_bluelight1b.vtf")
		TB:SetKeyValue("renderamt", 255)
		TB:SetKeyValue("rendercolor", "255 255 255")
		TB:SetKeyValue("life", 0.1)
		TB:SetKeyValue("damage", 0)
		TB:SetKeyValue("LightningStart", "TS"..rnd)
		TB:SetKeyValue("LightningEnd", "TE"..rnd)
		TB:SetKeyValue("spawnflags", 1)
		TB:SetKeyValue("TouchType", 0)
		TB:SetKeyValue("framestart", 0)
		TB:SetKeyValue("framerate", 0)
		TB:SetKeyValue("NoiseAmplitude", 5)
		TB:SetKeyValue("TextureScroll", 35)
		TB:SetKeyValue("BoltWidth", 1)
		TB:SetKeyValue("Radius", 256)
		TB:SetKeyValue("StrikeTime", 1)
		local TB2 = ents.Create("env_beam")
		TB2:SetKeyValue("texture", "sprites/physcannon_bluelight1b.vtf")
		TB2:SetKeyValue("renderamt", 255)
		TB2:SetKeyValue("rendercolor", "255 255 255")
		TB2:SetKeyValue("life", 0.1)
		TB2:SetKeyValue("damage", 0)
		TB2:SetKeyValue("LightningStart", "TS"..rnd)
		TB2:SetKeyValue("LightningEnd", "TE"..rnd)
		TB2:SetKeyValue("spawnflags", 1)
		TB2:SetKeyValue("TouchType", 0)
		TB2:SetKeyValue("framestart", 0)
		TB2:SetKeyValue("framerate", 0)
		TB2:SetKeyValue("NoiseAmplitude", 3)
		TB2:SetKeyValue("TextureScroll", 35)
		TB2:SetKeyValue("BoltWidth", 8)
		TB2:SetKeyValue("Radius", 256)
		TB2:SetKeyValue("StrikeTime", 1)
		TS:Spawn()
		TE:Spawn()
		TB:Spawn()
		TB2:Spawn()
		TB:Fire("turnon","","")
		TB2:Fire("turnon","","")
		TB:Fire("kill","",0.1)
		TB2:Fire("kill", "", 0.1)
		TE:Fire("kill", "", 0.1)
		TS:Fire("kill", "", 0.1)
		local e = EffectData()
		e:SetMagnitude(30)
		e:SetScale(30)
		e:SetRadius(30)
		e:SetOrigin(trace.HitPos)
		e:SetNormal(trace.HitNormal)
		util.Effect("ManhackSparks", e)
		local new = self.Owner:GetAimVector()
		new.z = 0.5
		if trace.Entity and trace.Entity:IsValid() then
			local e = EffectData()
			e:SetEntity(trace.Entity)
			e:SetMagnitude(30)
			e:SetScale(30)
			e:SetRadius(30)
			util.Effect("TeslaHitBoxes", e)
			trace.Entity:EmitSound("ambient/energy/zap"..math.random(1,3)..".wav")
			timer.Simple(math.random()*math.random(1,2), SGravZap, trace.Entity, 1)
			trace.Entity:TakeDamage(0,self.Owner)
			trace.Entity:SetVelocity(new*800)
			local bullet = {}
			bullet.Num 	= 1
			bullet.Src 	= self.Owner:GetShootPos()			
			bullet.Dir 	= self.Owner:GetAimVector()			
			bullet.Spread 	= 0	
			bullet.Tracer	= 0					 
			bullet.Force	= 99999999999999999
			bullet.Damage	= 1
			bullet.AmmoType = "pistol"
			self.Owner:FireBullets(bullet)
		end
		self.Owner:SetVelocity(new*-1000)
	end
end

function SWEP:SecondaryAttack()	
	if ( !self:CanPrimaryAttack() ) then return end
	if self.Del < CurTime() then
		self:TakePrimaryAmmo( 1 )
		self.Del = CurTime() + 0.25
	end
	local trace = self.Owner:GetEyeTrace()
	if trace.Entity and trace.Entity:IsValid() then
		if trace.Entity:GetPhysicsObject():IsValid() then
			trace.Entity:GetPhysicsObject():ApplyForceCenter(self.Owner:GetAimVector()*-1024)
		end
	end
end

function SWEP:ForceLaunch()
	if SERVER then
		if not self.Pulling then
			self.Const:Remove()
			self.HackEnt:Remove()
		end
		self.HeldEnt:SetCollisionGroup(COLLISION_GROUP_INTERACTIVE)
		local phys = self.HeldEnt:GetPhysicsObject()
		phys:EnableCollisions(true)
		phys:EnableGravity(true)
		phys:EnableDrag(true)
		phys:EnableMotion(true)
		phys:SetMass(self.HeldEntMass)
		phys:ApplyForceCenter(self.Owner:GetAimVector()*999)
		local rnd = math.random(1,99999)
		local TS = ents.Create("info_target")
		TS:SetPos((self.Owner:GetRight()*100)+(self.Owner:GetShootPos()+((self.Owner:GetAimVector()*50)+Vector(0,0,-100))))
		TS:SetName("TS"..rnd)
		local TE = ents.Create("info_target" )
		TE:SetPos(self.HeldEnt:GetPos())
		TE:SetName("TE"..rnd)
		local TB = ents.Create("env_beam")
		TB:SetKeyValue("texture", "sprites/physcannon_bluelight1b.vtf")
		TB:SetKeyValue("renderamt", 255)
		TB:SetKeyValue("rendercolor", "255 255 255")
		TB:SetKeyValue("life", 0.1)
		TB:SetKeyValue("damage", 0)
		TB:SetKeyValue("LightningStart", "TS"..rnd)
		TB:SetKeyValue("LightningEnd", "TE"..rnd)
		TB:SetKeyValue("spawnflags", 1)
		TB:SetKeyValue("TouchType", 0)
		TB:SetKeyValue("framestart", 0)
		TB:SetKeyValue("framerate", 0)
		TB:SetKeyValue("NoiseAmplitude", 5)
		TB:SetKeyValue("TextureScroll", 35)
		TB:SetKeyValue("BoltWidth", 1)
		TB:SetKeyValue("Radius", 256)
		TB:SetKeyValue("StrikeTime", 1)
		local TB2 = ents.Create("env_beam")
		TB2:SetKeyValue("texture", "sprites/physcannon_bluelight1b.vtf")
		TB2:SetKeyValue("renderamt", 255)
		TB2:SetKeyValue("rendercolor", "255 255 255")
		TB2:SetKeyValue("life", 0.1)
		TB2:SetKeyValue("damage", 0)
		TB2:SetKeyValue("LightningStart", "TS"..rnd)
		TB2:SetKeyValue("LightningEnd", "TE"..rnd)
		TB2:SetKeyValue("spawnflags", 1)
		TB2:SetKeyValue("TouchType", 0)
		TB2:SetKeyValue("framestart", 0)
		TB2:SetKeyValue("framerate", 0)
		TB2:SetKeyValue("NoiseAmplitude", 3)
		TB2:SetKeyValue("TextureScroll", 35)
		TB2:SetKeyValue("BoltWidth", 8)
		TB2:SetKeyValue("Radius", 256)
		TB2:SetKeyValue("StrikeTime", 1)
		TS:Spawn()
		TE:Spawn()
		TB:Spawn()
		TB2:Spawn()
		TB:Fire("turnon","","")
		TB2:Fire("turnon","","")
		TB:Fire("kill","",0.1)
		TB2:Fire("kill", "", 0.1)
		TE:Fire("kill", "", 0.1)
		TS:Fire("kill", "", 0.1)
		local bullet = {} --much more effective then applyforce center for ragdolls
		bullet.Num 	= 1
		bullet.Src 	= self.Owner:GetShootPos()			
		bullet.Dir 	= self.Owner:GetAimVector()			
		bullet.Spread 	= 0	
		bullet.Tracer	= 0					 
		bullet.Force	= 9999999999
		bullet.Damage	= 1
		bullet.AmmoType = "pistol"
		self.Owner:FireBullets(bullet)
	end
	local e = EffectData()
	e:SetEntity(self.HeldEnt)
	e:SetMagnitude(30)
	e:SetScale(30)
	e:SetRadius(30)
	util.Effect("TeslaHitBoxes", e)
	self.HeldEnt:EmitSound("ambient/energy/zap"..math.random(1,3)..".wav")
	timer.Simple(math.random()*math.random(1,2), SGravZap, self.HeldEnt, 1)
	for k,v in pairs(ents.FindInSphere(self.HeldEnt:GetPos(), 25)) do
		if (v == self.Owner) then return end
		local e = EffectData()
		e:SetEntity(v)
		e:SetMagnitude(30)
		e:SetScale(30)
		e:SetRadius(30)
		util.Effect("TeslaHitBoxes", e)
	end
	self.Weapon:EmitSound("weapons/physcannon/superphys_launch"..math.random(1,4)..".wav")
	self:ResetVars()
end

function SWEP:Deploy()
	self.Weapon:EmitSound("weapons/physcannon/physcannon_charge.wav")
	self:ResetVars()
	self.Secondary.Automatic = true
end

function SGravZap(ent, x)
	if not ent:IsValid() then return end
	ent:EmitSound("ambient/energy/zap"..math.random(1,3)..".wav")
	local e = EffectData()
	e:SetEntity(ent)
	e:SetMagnitude(30)
	e:SetScale(30)
	e:SetRadius(30)
	util.Effect("TeslaHitBoxes", e)
	x = x+1
	if (x <= math.random(3,7)) then
		timer.Simple(math.random()*math.random(1,2), SGravZap, ent, x)
	end
end
