AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
AddCSLuaFile("cl_Menu.lua")
AddCSLuaFile("cl_scoreboard.lua")

function GM:ShowHelp(pl)
	--Do nottin.
end

function GM:PlayerInitialSpawn(pl)

	timer.Simple(1.5,
	function()

		if BanTable != nil && BanTable != NULL && BanTable != "" then
			local ID = string.lower(string.Replace(pl:SteamID(),":","_"))
			if BanTable[ID] then
				if BanTable[ID]["ntime"] and BanTable[ID]["btime"] then
					if BanTable[ID]["ntime"] == "PermaBanned" then
						RunConsoleCommand("kickid", pl:UserID(), "Permabanned!")
					elseif (os.time() - BanTable[ID]["btime"]) <= BanTable[ID]["ntime"] then
						local Minutes = math.floor(((BanTable[ID]["ntime"] - (os.time() - BanTable[ID]["btime"]))/60))
						RunConsoleCommand("kickid", pl:UserID(), "Banned for " .. Minutes .. " minutes!")
					elseif (os.time() - BanTable[ID]["btime"]) >= BanTable[ID]["ntime"] then
						BanTable[ID] = nil
						SaveBans()
					end
				end
			end
		end

	end)

	local cl_playermodel = pl:GetInfo( "cl_playermodel" )
	local cl_model = player_manager.TranslatePlayerModel( cl_playermodel )
	util.PrecacheModel( cl_model )
	pl:SetModel( cl_model )
	pl.NextPirate = CurTime()
	timer.Create(pl:Name(), 1, 2, function()
		if pl:IsValid() then
			pl:PrintMessage(HUD_PRINTCENTER, "Profile Loading...")
		end
	end) 
	pl.Save = CurTime()
	pl.Allow = false
	pl.ClickWait = CurTime() - 5
	pl.SpawnWait = CurTime()
	
	timer.Simple(3, function()
		LoadShits(pl)
	end)
end

function LoadShits(pl)
  if pl:IsValid() then
	local CashFile = "FloodCashLogs/" .. pl:UniqueID() .. ".txt"

	if file.Exists("FloodWeapons/"..string.Replace(pl:SteamID(),":","_")..".txt") then
		local In = file.Read("FloodWeapons/"..string.Replace(pl:SteamID(),":","_")..".txt")
		In = string.Explode("\n",In)
		pl.Weapons = In;
		pl.WepLoad = true
	else
		pl.Weapons = {}
		table.insert(pl.Weapons, "weapon_pistol")
		local Out = string.Implode("\n",pl.Weapons)
		file.Write("FloodWeapons/"..string.Replace(pl:SteamID(),":","_")..".txt",Out)
		pl.WepLoad = true
	end

	if file.Exists("FloodVIP.txt") then
		local VIPIn = file.Read("FloodVIP.txt")
		VIPIn = string.Explode("\n",VIPIn)
		if table.HasValue( VIPIn, string.Replace(pl:SteamID(),":","_") ) then
		pl:SetNWInt("VIP", 1)
		pl:SetTeam(5)
		else
		pl:SetNWInt("VIP", 0)
		end
	else
		local VIP = {}
		local VIPOut = string.Implode("\n",VIP)
		file.Write("FloodVIP.txt",VIPOut)
	end

	if file.Exists("FloodAdmin.txt") then
		local VIPIn = file.Read("FloodAdmin.txt")
		VIPIn = string.Explode("\n",VIPIn)
		if table.HasValue( VIPIn, string.Replace(pl:SteamID(),":","_") ) then
		pl:SetNWInt("VIP", 2)
		pl:SetTeam(2)
		end
	else
		local VIP = {}
		local VIPOut = string.Implode("\n",VIP)
		file.Write("FloodAdmin.txt",VIPOut)
	end
	
	if file.Exists("FloodProtection/"..string.Replace(pl:SteamID(),":","_")..".txt") then
		local In = file.Read("FloodProtection/"..string.Replace(pl:SteamID(),":","_")..".txt")
		In = string.Explode("\n",In)
		pl.Buddies = In
		pl.BudLoad = true
	else
		pl.Buddies = {}
		local Out = string.Implode("\n",pl.Buddies)
		file.Write("FloodProtection/"..string.Replace(pl:SteamID(),":","_")..".txt",Out)
		pl.BudLoad = true
	end
	
	if file.Exists(CashFile) then
		pl:SetNWInt("Cash", tonumber(file.Read(CashFile)))
		pl.CashLoad = true
	else
		file.Write(CashFile, 5000)
		pl:SetNWInt("Cash", 5000)
		pl.CashLoad = true
	end
	
	if pl.WepLoad and pl.CashLoad then
		pl:PrintMessage(HUD_PRINTCENTER, "Profile sucessfully loaded.")
		pl.Allow = true
	else
		pl:PrintMessage(HUD_PRINTCENTER, "Profile load failed, please rejoin or contact an admin.")
	end
  end
end

function GM:PlayerSpawn(pl)
	if TimerStatus == 1 then
		pl:UnSpectate()
		if pl:GetNWInt("VIP") == 1 then
		pl:SetTeam(5)
		elseif pl:GetNWInt("VIP") == 2 then
		pl:SetTeam(2)
		else
		pl:SetTeam(3)
		end
		local cl_playermodel = pl:GetInfo( "cl_playermodel" )
		local cl_model = player_manager.TranslatePlayerModel( cl_playermodel )
		util.PrecacheModel( cl_model )
		pl:SetModel( cl_model )
		pl:StripWeapons()
		pl:RemoveAllAmmo()
		pl:Give( "weapon_physgun" )
		pl:Give( "weapon_physcannon" )
		pl:Give( "weapon_stunstick" )
		pl:Give( "gmod_tool" )
	elseif TimerStatus == 2 then
		pl:StripWeapons()
		pl:RemoveAllAmmo()
		pl:SetTeam(3)
	elseif TimerStatus == 3 or TimerStatus == 4 then
		pl:StripWeapons()
		pl:RemoveAllAmmo()
		pl:SetTeam(4)
		pl:KillSilent()
	end
end

function Purchase(pl, cmd, args)
	if pl.Allow then
		local Weapon = args[1]
		if table.HasValue(pl.Weapons, Weapon) then
			pl:ChatPrint("You have already purchased this weapon.")
		elseif Weapons[Weapon] then
			if pl:GetNWInt("Cash") >= Weapons[Weapon].WCOST then
				pl:SetNWInt("Cash", pl:GetNWInt("Cash") - Weapons[Weapon].WCOST)
				DoIt(pl, Weapon)
				pl:ChatPrint(Weapons[Weapon].WNAME .. " Purchased.")
			else
				pl:ChatPrint("You do not have enough cash for this!")
			end
		else
			pl:ChatPrint("Nonexistant weapon.")
		end
	else
		pl:ChatPrint("Wait for your profile to load before you try to buy this!")
	end
end
concommand.Add("Purchase", Purchase)

function DoIt(pl, Weapon)
	table.insert(pl.Weapons, Weapon)
	local Out = string.Implode("\n",pl.Weapons);
	file.Write("FloodWeapons/"..string.Replace(pl:SteamID(),":","_")..".txt",Out);
end

function SaveProfile()
	for k, v in pairs(player.GetAll()) do
		if v.Allow then
			if v.Save + CS < CurTime() then
				local CashFile = "FloodCashLogs/" .. v:UniqueID() .. ".txt"
				if file.Exists(CashFile) then
					file.Write(CashFile, v:GetNWInt("Cash"))
				else
					file.Write(CashFile, v:GetNWInt("Cash"))
				end
				v:ChatPrint("Profile saved!")
				v.Save = CurTime() + CS
			end
		end
	end
end

function PropsOn()
	for k, v in pairs(ents.GetAll()) do
		if v:GetNetworkedEntity("FloodOwner") != nil && v:GetNetworkedEntity("FloodOwner") != NULL && v:GetNetworkedEntity("FloodOwner") != "" then
			v.On = true
		end
	end
	for k, v in pairs(player.GetAll()) do
		if v:GetMoveType() == MOVETYPE_NOCLIP then
			v:SetPos( v:GetPos() + ( v:GetVelocity():GetNormal() * -40 ) )
			v:SetMoveType( MOVETYPE_WALK )
		end
	end
end

function PropsOff()
	for k, v in pairs(ents.GetAll()) do
		if v:GetNetworkedEntity("FloodOwner") != nil && v:GetNetworkedEntity("FloodOwner") != NULL && v:GetNetworkedEntity("FloodOwner") != "" then
			v.On = false
		end
	end
end

function RefundProps()
	for k, v in pairs(ents.GetAll()) do
		if v:GetNetworkedEntity("FloodOwner") != nil && v:GetNetworkedEntity("FloodOwner") != NULL && v:GetNetworkedEntity("FloodOwner") != "" then
			local pl = v:GetNetworkedEntity("FloodOwner")
			local Currentmass = tonumber(v:GetNWInt("PropHealth"))
			local Currentcash = pl:GetNWInt("Cash")
			if Props[v:GetModel()] then
				Recieve = math.floor((Currentmass / Props[v:GetModel()].HEALTH) * Props[v:GetModel()].COST)
			end
			if Recieve > 0 then
				local Give = (Currentcash + Recieve)
				v:Remove()
				pl:SetNWInt("Cash", math.floor(Give))
			else
				v:Remove()
			end
		end
	end
end

function RefundAll(pl, cmd, arg)
	if pl:GetNWInt("VIP") > 1 then
		for k, v in pairs(ents.GetAll()) do
			if v:GetNetworkedEntity("FloodOwner") != nil && v:GetNetworkedEntity("FloodOwner") != NULL && v:GetNetworkedEntity("FloodOwner") != "" then
				local pl = v:GetNetworkedEntity("FloodOwner")
				local Currentmass = tonumber(v:GetNWInt("PropHealth"))				--Props current health
				local Currentcash = pl:GetNWInt("Cash") 									--Players current cash.
				local phys = v:GetPhysicsObject() 									--Physics of the entity.
				local Calc = phys:GetMass()												--Entities mass.
				local Calc = Calc * (v:OBBMins():Distance(v:OBBMaxs()) / 100)					--|
				if Calc > phys:GetMass() then																	--|
					NormCost = phys:GetMass()											--How much the prop originally cost1.	--|
				elseif Calc < phys:GetMass() then										--How much the prop originally cost2.	--|
					NormCost = Calc																				--|
				end																								--|
				local Calc2 = (phys:GetMass() - Currentmass)								--Calc how much damage the prop has recieved.
				local Recieve = (NormCost - Calc2)											--Calc how much the player will return.(Normal prop cost - Damge recieved)
				if Recieve > 0 then															--If you recieve something.
					local Give = (Currentcash + Recieve)									--I'm going crazy with vars!
					v:Remove()														--Remove it.
					pl:SetNWInt("Cash", math.floor(Give))									--Give it.
				else																		--If the recieve amount is less then 0 given nothing.
				v:Remove()														--Remove it.
				end		
			end
		end
	end
end
concommand.Add("RefundAll", RefundAll)
--[[
function PayDay()

	if WP <= CurTime() then
		for k,v in pairs(player.GetAll()) do
			if v.Allow then
				if v:Alive() then
					local PlCash = v:GetNWInt("Cash")
					v:SetNWInt("Cash", PlCash + PS)
				end
			end
		end
		WP = CurTime() + 1
	end
end
]]--
function RecieveBonus()

	for k,v in pairs(player.GetAll()) do
		if v:Alive() then
			local PlCash = v:GetNWInt("Cash")
			v:SetNWInt("Cash", PlCash + 1500)
			v:ChatPrint("You have survived the round and get a bonus of $1500!")
		end
			v:ChatPrint("All your props have been refunded.")
	end
end


function ResetHealth()

	for k,v in pairs(player.GetAll()) do
		if v:Alive() then
			v:SetHealth(100)
		end
	end
end

function FoundWinner()
local Everyone = player.GetAll()
local Dead = team.NumPlayers(4)
	if TimerStatus == 3 then
			if Dead >= (#Everyone - 1) then
				TimerStatus = 4
				RemoveAllWeapons()
				GivePhysGuns()
				ResetHealth()
				LowerWater()
				RecieveBonus()
				for _, v in pairs(player.GetAll()) do
					SaveCash(v)
				end
				FightTime = FIV
			end
	end
end

function RemoveDEnts(pl)

	for k, v in pairs(ents.GetAll()) do
		if v:GetNetworkedEntity("FloodOwner") == pl then
			v:Remove()
		end
	end

	--Notify people, player left.
	for k, v in pairs(player.GetAll()) do
		v:ChatPrint(pl:Name() .. "'s props have been deleted.")
	end
end

function RemovePhysGuns()

	for k,v in pairs(player.GetAll()) do
		if v:Alive() then
			if v:GetWeapon("weapon_physgun") then
				v:GetWeapon("weapon_physgun"):Remove()
			end
			
			if v:GetWeapon("weapon_physcannon") then
				v:GetWeapon("weapon_physcannon"):Remove()
			end
			
			if v:GetWeapon("gmod_tool") then
				v:GetWeapon("gmod_tool"):Remove()
			end
			
			if v:GetWeapon("weapon_stunstick") then
				v:GetWeapon("weapon_stunstick"):Remove()
			end
		end
	end
end

function GivePhysGuns()

	for k,v in pairs(player.GetAll()) do
		if v:Alive() then
				v:Give("weapon_physgun")
				v:Give( "weapon_physcannon" )
				v:Give( "weapon_stunstick" )
				v:Give("gmod_tool")
		end
	end
end

function GivePistols()

	for k,v in pairs(player.GetAll()) do
		if v:Alive() then
		v:RemoveAllAmmo()
		if v.Weapons then
			for key, wep in pairs(v.Weapons) do
				v:Give(wep)
				v:GiveAmmo(9999, "Pistol")
				v:GiveAmmo(9999, "357")
				if Weapons[wep] then
				v:GiveAmmo(Weapons[wep].WAMMO, Weapons[wep].WAMMOTYPE)
				end
			end
		else
			v:Give("weapon_pistol")
			v:GiveAmmo(999999, "Pistol")
		end
		end
	end
end

function RemoveAllWeapons()

	for k, pl in pairs(player.GetAll()) do
		if pl:Alive() then
			pl:StripWeapons()
			pl:RemoveAllAmmo()
		end
	end
end

function UnfreezeProps()

	for k,v in pairs(ents.GetAll()) do
		local entphys = v:GetPhysicsObject()
		
		if entphys:IsValid() then 
			entphys:EnableMotion(true)
			entphys:Wake()
		end
	end
end

function GetID(pl, cmd, arg)

	if pl:IsSuperAdmin() then
		for k, v in pairs(player.GetAll()) do
			pl:ChatPrint(v:Nick() .. ": " .. v:UniqueID())
		end
	end
end
concommand.Add("GetID", GetID)

function GetPlayerbyNick( Nick )
	local lNAME = string.lower(Nick)

	for _,pl in pairs(player.GetAll()) do
		local name = pl:Nick()
		if (string.lower(string.sub(name, 1, #lNAME)) == lNAME) then
			return pl
		end
	end
	
	return nil
end

function FM_Slay(pl, cmd, arg)
	if pl:IsAdmin() or pl:IsSuperAdmin() or pl:GetNWInt("VIP") > 0 then
		if GetPlayerbyNick(arg[1]) ~= nil then
			if GetPlayerbyNick(arg[1]):Alive() then
				GetPlayerbyNick(arg[1]):Kill()
				for k, v in pairs(player.GetAll()) do
						v:ChatPrint(arg[1] .. " has been slayed by " .. pl:Nick())
				end
			end
		end
	end
end
concommand.Add("FM_Slay", FM_Slay)

function FM_SetMoney(pl, cmd, arg)
	if pl:IsAdmin() or pl:IsSuperAdmin() or pl:GetNWInt("VIP") > 1 then
		if GetPlayerbyNick(arg[1]) ~= nil then
			if GetPlayerbyNick(arg[1]):Alive() then
				GetPlayerbyNick(arg[1]):SetNWInt("Cash", tonumber(arg[2]))
				for k, v in pairs(player.GetAll()) do
						v:ChatPrint(pl:Nick() .. " set " ..arg[1].. "'s $ to " .. arg[2])
				end
			end
		end
	end
end
concommand.Add("FM_SetMoney", FM_SetMoney)

function FM_Kick( pl, cmd, arg )
	local Nick = arg[1]
	if pl:IsAdmin() or pl:IsSuperAdmin() or pl:GetNWInt("VIP") > 0 then
		if GetPlayerbyNick( Nick ) ~= nil then
			RunConsoleCommand("kick", Nick)
			for k, v in pairs(ents.GetAll()) do
				if v:GetNetworkedEntity("FloodOwner") == GetPlayerbyNick(Nick) then
					v:Remove()
				end
			end
			for k, v in pairs(player.GetAll()) do
				v:ChatPrint(Nick .. " has been kicked by " .. pl:Nick())
			end
		end
	end
end
concommand.Add( "FM_Kick", FM_Kick ) 

function FM_Ban( pl, command, arg )
	if pl:IsAdmin() or pl:IsSuperAdmin() or pl:GetNWInt("VIP") > 1 then
		if GetPlayerbyNick( arg[1] ) ~= nil then
			if tonumber(arg[2]) ~= 0 then
				//First convert the text values to seconds
				local bantime = arg[2]
				if arg[2] == "5 Minutes" then
					bantime = 300
				elseif arg[2] == "15 Minutes" then
					bantime = 900
				elseif arg[2] == "30 Minutes" then
					bantime = 1800
				elseif arg[2] == "1 Hour" then
					bantime = 3600
				elseif arg[2] == "2 Hours" then
					bantime = 7200
				elseif arg[2] == "6 Hours" then
					bantime = 21600
				elseif arg[2] == "1 Day" then
					bantime = 86400
				elseif arg[2] == "2 Days" then
					bantime = 172800
				elseif arg[2] == "7 Days" then
					bantime = 604800
				elseif arg[2] == "1 Month" then
					bantime = 2592000
				elseif arg[2] == "6 Months" then
					bantime = 15552000
				elseif arg[2] == "1 Year" then
					bantime = 31104000
				elseif arg[2] == "Forever" then
					bantime = "PermaBanned"
				else
					bantime = 1
				end

				local PID = string.lower(string.Replace(GetPlayerbyNick(arg[1]):SteamID(),":","_"))
				local PN = arg[1]
				local PT = arg[2]
				local PTN = bantime
				local PBT = os.time()
				
				Table = {}
				Table[PID] = {}
				Table[PID]["steamid"] = PID
				Table[PID]["nick"] = PN
				Table[PID]["time"] = PT
				Table[PID]["ntime"] = PTN
				Table[PID]["btime"] = PBT
				table.Merge(BanTable, Table)
				
				RunConsoleCommand("kickid", GetPlayerbyNick(arg[1]):UserID(), "Banned for " .. arg[2] .. "!")
				SaveBans()
				for k, v in pairs(ents.GetAll()) do
					if v:GetNetworkedEntity("FloodOwner") == GetPlayerbyNick(arg[1]) then
						v:Remove()
					end
				end
				for k, v in pairs(player.GetAll()) do
					if arg[2] == "Forever" then
						arg[2] = "ever"
						v:ChatPrint(arg[1] .. " has been banned by " .. pl:Nick() .. " for " .. arg[2])
						v:ChatPrint(arg[1].."'s props have been removed.")
					else
						v:ChatPrint(arg[1] .. " has been banned by " .. pl:Nick() .. " for " .. arg[2])
						v:ChatPrint(arg[1].."'s props have been removed.")
					end
				end
			else
				local PID = string.lower(string.Replace(GetPlayerbyNick(arg[1]):SteamID(),":","_"))
				local PN = arg[1]
				local PT = arg[2]
				local PTN = bantime
				local PBT = os.time()
				
				Table = {}
				Table[PID] = {}
				Table[PID]["steamid"] = PID
				Table[PID]["nick"] = PN
				Table[PID]["time"] = PT
				Table[PID]["ntime"] = PTN
				Table[PID]["btime"] = PBT
				table.Merge(BanTable, Table)

				for k, v in pairs(ents.GetAll()) do
					if v:GetNetworkedEntity("FloodOwner") == GetPlayerbyNick(arg[1]) then
						v:Remove()
					end
				end
				RunConsoleCommand("kickid", GetPlayerbyNick(arg[1]):UserID(), "Permabanned!")
				SaveBans()
				for k, v in pairs(player.GetAll()) do
					v:ChatPrint(arg[1] .. " has been permabanned by " .. pl:Nick())
				end
			end
		end
	end
end
concommand.Add( "FM_Ban", FM_Ban ) 

function SaveBans()
		file.Write("FloodBans/Bans.txt", util.TableToKeyValues(BanTable))
end

function GM:PlayerNoClip(pl)
	if pl:GetNWInt("VIP") > 1 then
		return true
	end
	if pl:GetMoveType() == MOVETYPE_NOCLIP then
		local pos = pl:GetPos()
		timer.Simple( FrameTime() * 0.5, function() 
			pl:SetPos( pos )
		end )
	end
	if TimerStatus == 1 or TimerStatus == 2 then
		return (pl:GetNWInt("VIP") == 1)
	else
		pl:ChatPrint("Sorry, only vips can noclip during build mode.")
		return false
	end
end

function GM:PlayerSay( player, text, teamonly )
	if string.lower(text) == "setcolour blue" then
	player:SetColor(0,0,255,255)
	player:ChatPrint("Gay blue.")
	return ""
	elseif string.lower(text) == "setcolour red" then
	player:SetColor(255,0,0,255)
	player:ChatPrint("Angry red.")
	return ""
	elseif string.lower(text) == "setcolour green" then
	player:SetColor(0,255,0,255)
	player:ChatPrint("Envy green.")
	return ""
	elseif string.lower(string.Left(text,6)) == "!give " then
	local str = string.Explode(" ",text)
	local cash = tonumber(str[3])
	if str[2] == nil then return "" end
	if str[3] == nil then return "" end
		if player:GetNWInt("Cash") > cash and cash > 0 then
			if GetPlayerbyNick(str[2]) ~= nil and GetPlayerbyNick(str[2]) ~= player then
				player:SetNWInt("Cash", player:GetNWInt("Cash") - cash)
				GetPlayerbyNick(str[2]):SetNWInt("Cash", GetPlayerbyNick(str[2]):GetNWInt("Cash") + cash)
				player:ChatPrint("You gave $" .. cash .. " to " .. str[2] .. ".")
				GetPlayerbyNick(str[2]):ChatPrint("You recieved $" .. cash .. " from " .. player:Nick() .. ".")
			elseif GetPlayerbyNick(str[2]) ~= nil and GetPlayerbyNick(str[2]) == player then
				player:ChatPrint("Did you just try to give yourself money?")
			else
				player:ChatPrint('No such person. ("' .. str[2] .. '")')
			end
		elseif cash < 0 then
		player:ChatPrint("Thought you were pretty smart huh?")
		else
		player:ChatPrint("Not enough cash.")
		end
	return ""
	else
	return text
	end
end

function RemoveIt(pl, cmd, arg)

	if TimerStatus == 1 then
		if pl.SpawnWait < CurTime() then
			if Props[arg[1]] then
				local tr = util.TraceLine(util.GetPlayerTrace(pl))
				local ent = ents.Create( "prop_physics" )
				if ( !ent:IsValid() ) then return end
				ent:SetModel(arg[1])
				ent:PhysicsInit( SOLID_VPHYSICS )
				ent:SetSolid( SOLID_VPHYSICS )
				ent:SetMoveType( MOVETYPE_VPHYSICS )
				local Raise = ent:OBBCenter():Distance(ent:OBBMins())
				ent:SetPos(tr.HitPos + Vector(0, 0, (Raise + 5)))
				ent:SetNetworkedEntity("Owner", pl)
				ent:SetNWInt("NAMEY", pl:Name())
				ent:Spawn()
				ent:Activate()
				ent:SetHealth(100000)
				ent:SetNWInt("PropHealth", Props[arg[1]].HEALTH)
				--local bone = ent:GetModelPhysBoneCount()
				local Bone = tr.PhysicsBone
				if pl:GetNWInt("Cash") < Props[arg[1]].COST then
					ent:Remove()
					pl:ChatPrint("You do not have enough money for this!")
				else
					pl:SetNWInt("Cash", pl:GetNWInt("Cash") - Props[arg[1]].COST)
				end
			end
		pl.SpawnWait = CurTime() + .2
		end
	end
end
concommand.Add( "RemoveIt", RemoveIt )

function PP(pl, cmd, arg)
local PPbool = false
	for kee, vee in pairs( player.GetAll() ) do
		userid = vee:UserID() .. ".00"
		if userid == arg[1] then
			PPSteamID = vee:SteamID()
			PPName = vee:GetName()
		end
	end
	if PPSteamID != nil then
	for k, v in ipairs(pl.Buddies) do
		if v == PPSteamID then
		table.remove( pl.Buddies, k )
		PPbool = true
		PPOut = string.Implode("\n",pl.Buddies)
		file.Write("FloodProtection/"..string.Replace(pl:SteamID(),":","_")..".txt",PPOut)								--Remove it.
		pl:ChatPrint(PPName .. " has been removed from your Prop-Protections list.")			
		end
	end
	if PPbool == false then
		table.insert( pl.Buddies, PPSteamID )
		PPOut = string.Implode("\n",pl.Buddies)
		file.Write("FloodProtection/"..string.Replace(pl:SteamID(),":","_")..".txt",PPOut)									--Remove it.
		pl:ChatPrint(PPName .. " has been added to your Prop-Protections list.")					
	end
	end
PPbool = false
end
concommand.Add( "PP", PP )

function GM:PlayerShouldTakeDamage(victim, attacker)	

	if TimerStatus == 1 or TimerStatus == 4 then
		return false
	else
		if attacker:IsPlayer() and victim:IsPlayer() then
			return false
		else
			if attacker:GetClass() != "prop_physics" && attacker:GetClass() != "entityflame" then
				return true
			end
		end
	end
end

function GM:PlayerDeath( pl, wep, killer )

	if pl:Team() != 4 then
		pl:SetTeam(4)
	end
	pl.specid = 1
	pl.Specatemode = OBS_MODE_CHASE
end

function GM:PlayerDeathThink(pl)
	
	local Owner = team.GetPlayers(1)
	local Admin = team.GetPlayers(2)
	local Three = team.GetPlayers(3)
	table.Add(Three, Owner)
	table.Add(Three, Admin)
	players = table.Copy(Three)
	
	if TimerStatus == 1 or TimerStatus == 2 then
		pl:UnSpectate()
		pl:Spawn()
	else
		if pl:KeyPressed( IN_JUMP ) then
				if pl.Specatemode == OBS_MODE_CHASE then
					pl.Specatemode = OBS_MODE_IN_EYE
					pl:SetPos(players[pl.specid]:GetPos())
					pl:UnSpectate()
					pl:Spectate(pl.Specatemode)
					pl:SpectateEntity( players[pl.specid] )
				elseif pl.Specatemode == OBS_MODE_IN_EYE then
					pl.Specatemode = OBS_MODE_CHASE
					pl:SetPos(players[pl.specid]:GetPos())
					pl:UnSpectate()
					pl:Spectate(pl.Specatemode)
					pl:SpectateEntity( players[pl.specid] )
				end
		elseif pl:KeyPressed( IN_ATTACK ) then
				if !pl.specid then
					pl.specid = 1
				end
				pl.specid = pl.specid + 1
			
				if pl.specid > #players then
					pl.specid = 1
				end

				pl:SetPos(players[pl.specid]:GetPos())
				pl:UnSpectate()
				pl:Spectate(pl.Specatemode)
				pl:SpectateEntity( players[pl.specid] )
		elseif pl:KeyPressed( IN_ATTACK2 ) then
				if !pl.specid then
					pl.specid = 1
				end
				pl.specid = pl.specid - 1

				if pl.specid <= 0 then
					pl.specid = #players
				end

				pl:SetPos(players[pl.specid]:GetPos())
				pl:UnSpectate()
				pl:Spectate(pl.Specatemode)
				pl:SpectateEntity( players[pl.specid] )
		end
	end
end

function checkOwnership( ply, ent )
	if ent:IsPlayer() or ent:IsNPC() then return true end -- Let players go through other players and npcs (too problematic otherwise)
	if ent:GetNetworkedEntity("FloodOwner") ~= ply and (table.HasValue(ent:GetNetworkedEntity("FloodOwner").Buddies,ply:SteamID()) == false) then
		return nil
	else
		return true
	end
end

-- Given a velocity, normalized velocity, and a normal:
-- Calculate the velocity toward the wall and remove it so we can "slide" across the wall.
function calcWallSlide( vel, normal )
	local toWall = normal * -1
	local velToWall = vel:Dot( toWall ) * toWall
	return vel - velToWall
end

function zeromove( move )
	move:SetVelocity( Vector( 0, 0, 0 ) )
	move:SetVelocity( Vector( 0, 0, 0 ) )
	move:SetForwardSpeed( 0 )
	move:SetSideSpeed( 0 )	
	move:SetUpSpeed( 0 )
end

-- Check if a player is stuck in an object or in the world.
-- Returns true and ent they're stuck on if they're stuck.
function isStuck( ply, filter )
	local ang = ply:EyeAngles()
	local directions = {
		ang:Right(),
		ang:Right() * -1,
		ang:Forward(),		
		ang:Forward() * -1,
		ang:Up(),
		ang:Up() * -1,
	}
	local ents = {}
	
	local t = {}
	t.start = ply:GetPos()
	t.filter = filter
	
	-- Check if they're stuck by checking each direction. A minimum number of directions should hit the same object if they're stuck.
	for _, dir in ipairs( directions ) do
		t.endpos = ply:GetPos() + dir
		local tr = util.TraceEntity( t, ply )
		if tr.Entity:IsValid() and tr.HitPos == tr.StartPos then
			ents[ tr.Entity ] = ents[ tr.Entity ] or 0
			ents[ tr.Entity ] = ents[ tr.Entity ] + 1
		end
	end
	
	for ent, hits in pairs( ents ) do
		if hits >= 4 then
			return true, ent
		end
	end
	
	return false
end

-- The brain of Uclip, this makes sure they can move where they want to.
function checkVel( ply, move, vel, recurse, hitnorms )
	if vel == Vector( 0, 0, 0 ) then return end -- No velocity, don't bother.
	
	local ft = FrameTime()
	local veln = vel:GetNormalized()
	hitnorms = hitnorms or {} -- This is used so we won't process the same normal more than once. (IE, we don't get a wedge where we have to process velocity to 0)
	
	recurse = recurse or 0 -- Keep track of how many recurses
	recurse = recurse + 1
	if recurse > 4 and 4 > 0 then -- Hard break
		zeromove( move )
		return
	end
	
	local t = {}
	t.start = ply:GetPos()
	t.endpos = ply:GetPos() + vel * ft + veln -- Add an extra unit in the direction they're headed just to be safe.
	t.filter = { ply }
	local tr = util.TraceEntity( t, ply )

	local loops = 0
	while tr.Hit do -- Recursively check all the hits. This is so we don't miss objects behind another object.
		loops = loops + 1
		if 50 > 0 and loops > 50 then 
			zeromove( move )			
			return
		end
		
		if tr.HitWorld or ( tr.Entity:IsValid() and (tr.Entity:GetClass() == "prop_dynamic" or (not checkOwnership( ply, tr.Entity ) and not isStuck( ply, t.filter ))) ) then -- If world or a prop they don't own that they're not stuck inside. Ignore prop_dynamic due to crash.
			local slide = calcWallSlide( vel, tr.HitNormal )
			move:SetVelocity( slide )			
			move:SetSideSpeed( 0 )
			move:SetForwardSpeed( 0 )
			move:SetUpSpeed( 0 )
			
			if table.HasValue( hitnorms, tr.HitNormal ) then -- We've already processed this normal. We can get this case when the player's noclipping into a wedge.
				zeromove( move )			
				return
			end
			table.insert( hitnorms, tr.HitNormal )					
			
			return checkVel( ply, move, slide, recurse, hitnorms ) -- Return now so this func isn't left on stack			
		end

		if tr.Entity and tr.Entity:IsValid() then -- Ent to add!
			table.insert( t.filter, tr.Entity )		
		end

		tr = util.TraceEntity( t, ply )
	end
end

function GM:Move(ply, move)
	if ply:GetMoveType() ~= MOVETYPE_NOCLIP then
		local ent = ply:GetGroundEntity()
		local pivec = Vector(math.Rand(-800,800),math.Rand(-800,800),500)
		if !ent:IsValid() or ply:IsWorld() or !ply:Alive() then return end
		return 
	end -- Not interested in anything but noclip
	local ft = FrameTime()

	local vel = move:GetVelocity() -- How far are they going to move this frame?
	-- We're tacking some extra velocity on because we don't have how much they're going to accelerate this frame.
	vel = vel + ply:EyeAngles():Forward() * move:GetForwardSpeed() / 4 * ft
	vel = vel + ply:EyeAngles():Right() * move:GetSideSpeed() / 4 * ft
	vel = vel + ply:EyeAngles():Up() * move:GetUpSpeed() / 3 * ft
	-- We're not doing any extra checks we should be here (approaching max, slowing down, etc) because it really doesn't matter enough to us.
	
	checkVel( ply, move, vel )
end
	