include('shared.lua')

function GM:SpawnMenuEnabled()
	return false
end

function GM:SpawnMenuOpen()
	return false
end

local PANEL = {}

function PANEL:Init()

	if Loaded == false || Loaded == nil || Loaded == NULL || Loaded == "" then
		AllTools = spawnmenu.GetTools()
		Msg("|================================|\n")
		Msg("|===Tables loaded successfully===|\n")
		Msg("|================================|\n")
		local Loaded = true
	end
	local tTables = AllTools
	
	MENU = self
	MENU:SetTitle("")
	MENU:ShowCloseButton(false)
	MENU:SetSize(ScrW() - 50, ScrH() - 50)
	MENU:SetPos(25, 25)
	MENU.Paint = function()
		surface.SetDrawColor(0, 0, 0, 0)
		surface.DrawRect(0, 0, MENU:GetWide(), MENU:GetTall())
	end

	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
	self.PropPanel = vgui.Create("DPropertySheet")												--| Prop tab.
	self.PropPanel:SetParent(MENU)																--|
	self.PropPanel:SetSize(((MENU:GetWide()*.5 - 5)), MENU:GetTall())							--|
	self.PropPanel:SetPos(0, 0)																	--|
																								--|
	self.PropsBackground = vgui.Create("DPanelList")											--| Prop background.
	self.PropsBackground:EnableVerticalScrollbar(true)											--|
	self.PropsBackground:SetPadding(5)															--|
	self.PropsBackground:SetSpacing(5)															--|
	self.PropsBackground:SetSize((self.PropPanel:GetWide() - 10), self.PropPanel:GetTall())		--|
	self.PropsBackground:SetPos(0, 0)															--|
	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
	

	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
	self.ToolPanel = vgui.Create("DPropertySheet")												--| Tool tab.
	self.ToolPanel:SetParent(MENU)																--|
	self.ToolPanel:SetSize(((MENU:GetWide()*.5 - 5)), MENU:GetTall())							--|
	self.ToolPanel:SetPos(((MENU:GetWide()*.5 + 5)), 0)											--|
																								--|
	self.ToolsBackground = vgui.Create("DPanelList")											--| Tool background.
	self.ToolsBackground:EnableHorizontal(true)													--|
	self.ToolsBackground:EnableVerticalScrollbar(false)											--|
	self.ToolsBackground:SetAutoSize(false)														--|
	self.ToolsBackground:SetPadding(0)															--|
	self.ToolsBackground:SetSpacing(5)															--|
	self.ToolsBackground:SetSize(0, 0)															--|
	self.ToolsBackground:SetPos(0, 0)															--|
	self.ToolsBackground.Paint = function()														--|
		surface.SetDrawColor(170, 170, 170, 255)												--|
		surface.DrawRect(0, 0, self.ToolsBackground:GetWide(), self.ToolsBackground:GetTall())	--|
	end																							--|
																								--|
	self.ToolList = vgui.Create("DPanelList")													--| Tool list background.
	self.ToolsBackground:AddItem(self.ToolList)													--|
	self.ToolList:EnableVerticalScrollbar(true)													--|
	self.ToolList:SetSize(self.ToolPanel:GetWide()*.33, self.ToolPanel:GetTall() - 31)			--|
	self.ToolList:SetPos(0, 0)																	--|
	self.ToolList:SetAutoSize( false ) 															--|
	self.ToolList:SetSpacing( 1 ) 																--|
	self.ToolList:SetPadding( 0 ) 																--|
																								--|
	self.Content = vgui.Create("DPanelList")													--| Context background.
	self.ToolsBackground:AddItem(self.Content)													--|
	self.Content:SetSize(self.ToolPanel:GetWide()*.63, self.ToolPanel:GetTall() - 31)			--|
	self.Content:EnableVerticalScrollbar(true)													--|
	self.Content:SetSpacing(0)																	--|
	self.Content:SetPadding(5)																	--|
	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|


	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
	self.WeaponsBackground = vgui.Create("DPanelList")			
	self.WeaponsBackground:EnableVerticalScrollbar(false) 								--|
	self.WeaponsBackground:SetPadding(5)															--|
	self.WeaponsBackground:SetSpacing(5)																	--|
	self.WeaponsBackground:SetSize((self.ToolPanel:GetWide() - 10), self.ToolPanel:GetTall())	--|
	self.WeaponsBackground:SetPos(0, 0)															--|
	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|

	
	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
	self.GroupBackground = vgui.Create("DPanelList")												--|
	self.GroupBackground:EnableVerticalScrollbar(false) 											--|
	self.GroupBackground:SetSize((self.ToolPanel:GetWide() - 10), self.ToolPanel:GetTall())		--|
	self.GroupBackground:SetPos(0, 0)															--|
	self.GroupBackground.Paint = function()
		surface.SetDrawColor(0, 0, 0, 255)												--|
		surface.DrawRect(0, 0, self.GroupBackground:GetWide(), self.GroupBackground:GetTall())--|
	end
	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|

	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------| Help background.
	self.HelpBackground = vgui.Create("DPanelList")												--|
	self.HelpBackground:EnableVerticalScrollbar(false) 											--|
	self.HelpBackground:SetSize((self.ToolPanel:GetWide() - 10), self.ToolPanel:GetTall())		--|
	self.HelpBackground:SetPos(0, 0)															--|
	self.HelpBackground.Paint = function()
		local Wide = self.HelpBackground:GetWide()
		local Height = self.HelpBackground:GetTall()
		local Title = "6 golden rules:"
		local One = "You must fight. That means no money rounds."
		local Two = "Do not attach, constraint, or stick props to the map."
		local Three = "Do not spam in any way. (Mic, props, chat)"
		local Four = "You may build sharks, but every 3 rounds."
		local Five = "Don't be disrespectful to other players."
		local Six = "Don't exploit any bugs or glitches."
		local Seven = "Breaking these rules will get you kicked or banned."
		surface.SetDrawColor(50, 50, 50, 255)													--|
		surface.DrawRect(0, 0, Wide, self.ToolsBackground:GetTall())--|
		surface.SetTextColor(255, 255, 255, 255)												--|
		
		surface.SetFont("Trebuchet20")															--|
		local TitleW, TitleH = surface.GetTextSize(Title)
		surface.SetTextPos(((Wide*.5) - (TitleW*.5)), ((Height*.03) - (TitleH*.5)))																--|
		surface.DrawText(Title)						

		surface.SetFont("Default")																--|
		local OneW, OneH = surface.GetTextSize(One)
		surface.SetTextPos(((Wide*.5) - (OneW*.5)), ((Height*.09) - (OneH*.5)))		
		surface.DrawText(One)													--|
		
		surface.SetFont("Default")																--|
		local TwoW, TwoH = surface.GetTextSize(Two)
		surface.SetTextPos(((Wide*.5) - (TwoW*.5)), ((Height*.12) - (TwoH*.5)))		
		surface.DrawText(Two)													--|
		
		surface.SetFont("Default")																--|
		local ThreeW, ThreeH = surface.GetTextSize(Three)
		surface.SetTextPos(((Wide*.5) - (ThreeW*.5)), ((Height*.15) - (ThreeH*.5)))		
		surface.DrawText(Three)													--|
		
		surface.SetFont("Default")																--|
		local FourW, FourH = surface.GetTextSize(Four)
		surface.SetTextPos(((Wide*.5) - (FourW*.5)), ((Height*.18) - (FourH*.5)))		
		surface.DrawText(Four)													--|
		
		surface.SetFont("Default")																--|
		local FiveW, FiveH = surface.GetTextSize(Five)
		surface.SetTextPos(((Wide*.5) - (FiveW*.5)), ((Height*.21) - (FiveH*.5)))		
		surface.DrawText(Five)													--|
		
		surface.SetFont("Default")																--|
		local SixW, SixH = surface.GetTextSize(Six)
		surface.SetTextPos(((Wide*.5) - (SixW*.5)), ((Height*.24) - (SixH*.5)))		
		surface.DrawText(Six)													--|
		
		surface.SetTextColor(200, 25, 25, 255)
		surface.SetFont("Default")																--|
		local SevenW, SevenH = surface.GetTextSize(Seven)
		surface.SetTextPos(((Wide*.5) - (SevenW*.5)), ((Height*.27) - (SevenH*.5)))		
		surface.DrawText(Seven)													--|
		surface.SetTextColor(255, 255, 255, 255)
	end
	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|												--|
	
	--[[-----------------------------------------------------------------------------------------------------------------------------------------------------------------------| Admin background.
	self.AdminBackground = vgui.Create("DPanelList")												--|
	self.AdminBackground:EnableVerticalScrollbar(false) 											--|
	self.AdminBackground:SetSize((self.ToolPanel:GetWide() - 10), self.ToolPanel:GetTall())		--|
	self.AdminBackground:SetPos(0, 0)															--|
	self.AdminBackground.Paint = function()
		surface.SetDrawColor(50, 50, 50, 255)													--|
		surface.DrawRect(0, 0, self.AdminBackground:GetWide(), self.AdminBackground:GetTall())--|
		surface.SetTextColor(255, 255, 255, 255)												--|
		
		local Title = "Admin menu under construction."
		surface.SetFont("Trebuchet20")															--|
		local TitleW, TitleH = surface.GetTextSize(Title)
		surface.SetTextPos(((self.AdminBackground:GetWide()*.5) - (TitleW*.5)), ((self.AdminBackground:GetTall()*.02) - (TitleH*.5)))																--|
		surface.DrawText(Title)	
	end
	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
	else--]]
	if LocalPlayer():GetNWInt("VIP") == 1 then
	self.AdminBackground = vgui.Create("DPanelList")												--|
	self.AdminBackground:EnableVerticalScrollbar(false) 											--|
	self.AdminBackground:SetSize((self.ToolPanel:GetWide() - 10), self.ToolPanel:GetTall())		--|
	self.AdminBackground:SetPos(0, 0)															--|
	self.AdminBackground.Paint = function()
		surface.SetDrawColor(170, 170, 170, 255)												--|
		surface.DrawRect(0, 0, self.AdminBackground:GetWide(), self.AdminBackground:GetTall())--|
		--[[surface.SetTextColor(255, 255, 255, 255)												--|
		
		local Title = "You must donate and become an admin to view this menu. Click the donations tab on the left."
		surface.SetFont("Trebuchet20")															--|
		local TitleW, TitleH = surface.GetTextSize(Title)
		surface.SetTextPos(((self.AdminBackground:GetWide()*.5) - (TitleW*.5)), ((self.AdminBackground:GetTall()*.02) - (TitleH*.5)))																--|
		surface.DrawText(Title)	--]]
	end
	end
	-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
	
   --[[ local Mod = vgui.Create("DButton")
    Mod:SetParent(self.DonateBackground)
    Mod:SetText( "Mod Package Info" )
    Mod:SetPos(((self.DonateBackground:GetWide()*.5) - (Mod:GetWide())), ((self.DonateBackground:GetTall()*.24) - (Vip:GetTall()*.5)))
    Mod:SetSize( 125, 25 )
    Mod.DoClick = function ( btn )
     ModOptions = DermaMenu()
	 ModOptions:AddOption("Mod cost: $5.00")
	 ModOptions:AddOption("Benefits:")
	 ModOptions:AddOption("Mod tag")
	 ModOptions:AddOption("vote ban")
     ModOptions:AddOption("vote kick")
	 ModOptions:AddOption("$5000 cash")
	 ModOptions:AddOption("Coloring tool")
     ModOptions:AddOption("Material tool")
	 ModOptions:AddOption("Ballsocker_adv tool")
	 ModOptions:AddOption("Noclip for build mode")
	 ModOptions:AddOption("Possibly more later on.")
     ModOptions:Open()
    end --]]

	self.SwepCatA = vgui.Create( "DCollapsibleCategory" ) 
	self.SwepCatA:SetSize( (self.ToolPanel:GetWide() - 10), 50 ) 
 	self.SwepCatA:SetLabel( "Light Weaponry" ) 	 
 	self.SwepContA = vgui.Create( "DPanelList" )
	self.SwepContA:EnableHorizontal(true)											--|
	self.SwepContA:EnableVerticalScrollbar(true)	
 	self.SwepContA:SetSpacing( 5 ) 
 	self.SwepContA:SetPadding( 5 ) 
 	self.SwepContA:SetAutoSize( true ) 		
	--self.SwepContA:SetSize((self.PropPanel:GetWide() - 10), self.PropPanel:GetTall())		--|	
 	self.SwepCatA:SetContents( self.SwepContA ) 
	self.WeaponsBackground:AddItem( self.SwepCatA ) 	
	 
	self.SwepCatB = vgui.Create( "DCollapsibleCategory" ) 
	self.SwepCatB:SetSize( (self.ToolPanel:GetWide() - 10), 50 ) 
 	self.SwepCatB:SetLabel( "Medium Weaponry" ) 	 
 	self.SwepContB = vgui.Create( "DPanelList" )
	self.SwepContB:EnableHorizontal(true)											--|
	self.SwepContB:EnableVerticalScrollbar(true)	
 	self.SwepContB:SetSpacing( 5 ) 
 	self.SwepContB:SetPadding( 5 ) 
 	self.SwepContB:SetAutoSize( true ) 		
 	self.SwepCatB:SetContents( self.SwepContB ) 
	self.WeaponsBackground:AddItem( self.SwepCatB ) 	
	 
	self.SwepCatC = vgui.Create( "DCollapsibleCategory" ) 
	self.SwepCatC:SetSize( (self.ToolPanel:GetWide() - 10), 50 ) 
 	self.SwepCatC:SetLabel( "Heavy Weaponry" ) 	 
 	self.SwepContC = vgui.Create( "DPanelList" )
	self.SwepContC:EnableHorizontal(true)											--|
	self.SwepContC:EnableVerticalScrollbar(true)	
 	self.SwepContC:SetSpacing( 5 ) 
 	self.SwepContC:SetPadding( 5 ) 
 	self.SwepContC:SetAutoSize( true ) 		
 	self.SwepCatC:SetContents( self.SwepContC ) 
	self.WeaponsBackground:AddItem( self.SwepCatC ) 	
	 
	self.SwepCatD = vgui.Create( "DCollapsibleCategory" ) 
	self.SwepCatD:SetSize( (self.ToolPanel:GetWide() - 10), 50 ) 
 	self.SwepCatD:SetLabel( "Miscellanea Weaponry" ) 	 
 	self.SwepContD = vgui.Create( "DPanelList" )
	self.SwepContD:EnableHorizontal(true)											--|
	self.SwepContD:EnableVerticalScrollbar(true)	
 	self.SwepContD:SetSpacing( 5 ) 
 	self.SwepContD:SetPadding( 5 ) 
 	self.SwepContD:SetAutoSize( true ) 		
 	self.SwepCatD:SetContents( self.SwepContD ) 
	self.WeaponsBackground:AddItem( self.SwepCatD ) 	
	 
	for k, v in pairs(Weapons) do
		local Sweps = vgui.Create("SpawnIcon")
		Sweps:SetModel(v.WMODEL)
		Sweps:SetToolTip("Name: " .. v.WNAME .. "\nCost: " .. v.WCOST .. "\nDamage: " .. v.WDAMAGE .. "\nDescription: " .. v.WNOTE)
		Sweps.DoClick = function()
			RunConsoleCommand("Purchase", k)
			MENU:SetVisible(false)
			RememberCursorPosition()
			gui.EnableScreenClicker(false)
		end
		if v.WTYPE == "Light" then
			self.SwepContA:AddItem(Sweps)
		elseif v.WTYPE == "Medium" then
			self.SwepContB:AddItem(Sweps)
		elseif v.WTYPE == "Heavy" then
			self.SwepContC:AddItem(Sweps)
		elseif v.WTYPE == "Misc" then
			self.SwepContD:AddItem(Sweps)
		else
			Sweps:Remove()
		end
	end
	
	if tTables then
		for k, v in pairs(tTables[1].Items) do 
			if ( type( v ) == "table" ) then 	 
				local Name = v.ItemName 
				local Label = v.Text 
				v.ItemName = nil 
				v.Text = nil 
				self:AddCategory( Name, Label, v ) 
			end
		end
	else
		LocalPlayer():ChatPrint("There has been an error loading your tools section, please rejoin the server or contact an administrator to fix this.")
	end

	self.PropsCatA = vgui.Create( "DCollapsibleCategory" ) 
	self.PropsCatA:SetSize( (self.ToolPanel:GetWide() - 10), 50 ) 
 	self.PropsCatA:SetLabel( "Wooden Props" ) 	 
 	self.PropsContA = vgui.Create( "DPanelList" )
	self.PropsContA:EnableHorizontal(true)	
 	self.PropsContA:SetAutoSize( true ) 				
 	self.PropsContA:SetSpacing( 5 ) 
 	self.PropsContA:SetPadding( 5 ) 
 	self.PropsCatA:SetContents( self.PropsContA ) 
	self.PropsBackground:AddItem( self.PropsCatA ) 	

	self.PropsCatB = vgui.Create( "DCollapsibleCategory" ) 
	self.PropsCatB:SetSize( (self.ToolPanel:GetWide() - 10), 50 ) 
 	self.PropsCatB:SetLabel( "Plastic Props" ) 	 
 	self.PropsContB = vgui.Create( "DPanelList" )
	self.PropsContB:EnableHorizontal(true)		
 	self.PropsContB:SetAutoSize( true ) 			
 	self.PropsContB:SetSpacing( 5 ) 
 	self.PropsContB:SetPadding( 5 ) 
 	self.PropsCatB:SetContents( self.PropsContB ) 
	self.PropsBackground:AddItem( self.PropsCatB ) 	

	self.PropsCatC = vgui.Create( "DCollapsibleCategory" ) 
	self.PropsCatC:SetSize( (self.ToolPanel:GetWide() - 10), 50 ) 
 	self.PropsCatC:SetLabel( "Metal Props" ) 	 
 	self.PropsContC = vgui.Create( "DPanelList" )
	self.PropsContC:EnableHorizontal(true)
 	self.PropsContC:SetAutoSize( true ) 	
 	self.PropsContC:SetSpacing( 5 ) 
 	self.PropsContC:SetPadding( 5 ) 	
 	self.PropsCatC:SetContents( self.PropsContC ) 
	self.PropsBackground:AddItem( self.PropsCatC ) 	

	self.PropsCatD = vgui.Create( "DCollapsibleCategory" ) 
	self.PropsCatD:SetSize( (self.ToolPanel:GetWide() - 10), 50 ) 
 	self.PropsCatD:SetLabel( "Miscellaneus Props" ) 	 
 	self.PropsContD = vgui.Create( "DPanelList" )
	self.PropsContD:EnableHorizontal(true)	
 	self.PropsContD:SetAutoSize( true ) 			
 	self.PropsContD:SetSpacing( 5 ) 
 	self.PropsContD:SetPadding( 5 ) 	
 	self.PropsCatD:SetContents( self.PropsContD ) 
	self.PropsBackground:AddItem( self.PropsCatD ) 	

	if Props then
		for k, v in pairs(Props) do
			local Props = vgui.Create("SpawnIcon")
			Props:SetModel(k)
			Props:SetToolTip("Cost: " .. v.COST .. "\nHealth: " .. v.HEALTH)
			Props.DoClick = function()
				local MDL = k
				RunConsoleCommand("RemoveIt", MDL)
			end
			if v.TYPE == "Wood" then
				self.PropsContA:AddItem(Props)
			elseif v.TYPE == "Plastic" then
				self.PropsContB:AddItem(Props)
			elseif v.TYPE == "Metal" then
				self.PropsContC:AddItem(Props)
			elseif v.TYPE == "Misc" then
				self.PropsContD:AddItem(Props)
			end
		end
	else
		LocalPlayer():ChatPrint("There has been an error loading your props section, please rejoin the server or contact an administrator to fix this.")
	end

	self.PropPanel:AddSheet("Props", self.PropsBackground, "gui/silkicons/brick_add", true, false)
	self.PropPanel:AddSheet("Weapons", self.WeaponsBackground, "gui/silkicons/bomb", true, false)
	self.ToolPanel:AddSheet("Tools", self.ToolsBackground, "gui/silkicons/wrench", false, false)
	self.ToolPanel:AddSheet("Help/Rules", self.HelpBackground, "gui/silkicons/exclamation", false, false)
	self.ToolPanel:AddSheet("Prop Protection", self.GroupBackground, "gui/silkicons/group", true, false)
end

function PANEL:AddCategory( Name, Label, tItems )
	
	self.Category = vgui.Create( "DCollapsibleCategory") 
 	self.ToolList:AddItem( self.Category ) 
 	self.Category:SetLabel( Label ) 
 	self.Category:SetCookieName( "ToolMenu."..tostring(Name) ) 
 	 
 	self.CategoryContent = vgui.Create( "DPanelList" ) 
 	self.CategoryContent:SetAutoSize( true ) 
 	self.CategoryContent:SetDrawBackground( false ) 
 	self.CategoryContent:SetSpacing( 0 ) 
 	self.CategoryContent:SetPadding( 0 ) 
 	self.Category:SetContents( self.CategoryContent ) 
 	 
	local bAlt = true
	 
 	for k, v in pairs( tItems ) do 
 		local Item = vgui.Create( "ToolMenuButton", self ) 
 		Item:SetText( v.Text ) 
 		Item.OnSelect = function( button ) self:EnableControlPanel( button ) end 
 		concommand.Add( Format( "tool_%s", v.ItemName ), function() Item:OnSelect() end ) 
		
 		if ( v.SwitchConVar ) then 
 			Item:AddCheckBox( v.SwitchConVar ) 
 		end 

 		Item.ControlPanelBuildFunction = v.CPanelFunction 
 		Item.Command = v.Command 
 		Item.Name = v.ItemName 
 		Item.Controls = v.Controls 
 		Item.Text = v.Text 

 		Item:SetAlt( bAlt ) 
 		bAlt = !bAlt 

 		self.CategoryContent:AddItem( Item ) 
 	end
end

 function PANEL:EnableControlPanel( button ) 
   
 	if ( self.LastSelected ) then 
 		self.LastSelected:SetSelected( false ) 
 	end 
 	 
 	button:SetSelected( true ) 
 	self.LastSelected = button 
   
 	local cp = controlpanel.Get( button.Name ) 
 	if ( !cp:GetInitialized() ) then 
 		cp:FillViaTable( button ) 
 	end 
 	 
 	self.Content:Clear() 
 	self.Content:AddItem( cp ) 
 	self.Content:Rebuild() 
	self:SetKeyboardInputEnabled( true )
	self:SetMouseInputEnabled( true )
	self.Content:SetKeyboardInputEnabled( true )
	self.Content:SetMouseInputEnabled( true )
	cp:SetKeyboardInputEnabled( true )
	cp:SetMouseInputEnabled( true )
	
 	g_ActiveControlPanel = cp 
 	 
	g_ActiveControlPanel:SetKeyboardInputEnabled( true )
	g_ActiveControlPanel:SetMouseInputEnabled( true )
	
 	if ( button.Command ) then 
 		LocalPlayer():ConCommand( button.Command ) 
 	end 
 		 
 end
 
function PANEL:Think()
	
end

function PANEL:Close()
 	MENU:Remove()
end

function PANEL:PerformLayout()

end

vgui.Register("menu", PANEL, "DFrame")


function ResetPPList()
	MENU.GroupBackground:Clear()
	for k, v in pairs( player.GetAll() ) do
		if LocalPlayer() != v then
		local PPs = vgui.Create("DButton")
		PPs:SetText( v:GetName() )
		PPs:SetSize( 200, 30)
		--PPsSteamID = v:SteamID()
		PPs.DoClick = function()
		RunConsoleCommand("PP", v:UserID())
		end
		MENU.GroupBackground:AddItem( PPs ) 	
		end
	end
end

function ResetPList(PL)
	MENU.PlayerList:Clear()
	for k, v in pairs(player.GetAll()) do
		if PL ~= v:Nick() then
			MENU.PlayerList:AddItem(v:Nick())
		end
	end
end
local function AdminMenu()

MENU.PlayerList = vgui.Create( "DComboBox")
MENU.PlayerList:SetParent( MENU.AdminBackground )
MENU.PlayerList:SetPos( 0, 0 )
MENU.PlayerList:SetSize( MENU.AdminBackground:GetWide()*.333, 225 )
MENU.PlayerList:SetMultiple( false ) // Don't use this unless you know extensive knowledge about tables
ResetPList()

MENU.Kick = vgui.Create( "DButton" )
MENU.Kick:SetParent( MENU.AdminBackground ) // Set parent to our "DermaPanel"
MENU.Kick:SetText("Kick")
MENU.Kick:SetPos( ((MENU.AdminBackground:GetWide()*.333) + 5), 0 )
MENU.Kick:SetSize( ((MENU.AdminBackground:GetWide()*.333) - 5), 50 )
	MENU.Kick.DoClick = function ()
		local Value = MENU.PlayerList:GetSelectedItems()[1]
		if Value != nil && Value != NULL && Value != "" then
			RunConsoleCommand("FM_Kick", Value:GetValue())
			local PlayerLeft = Value:GetValue()
			ResetPList(PlayerLeft)
		else
			print("No player selected!")
		end
	end 
	
	MENU.BanTime = vgui.Create("DMultiChoice")
	MENU.BanTime:SetParent( MENU.AdminBackground )
	MENU.BanTime:SetPos( ((MENU.AdminBackground:GetWide()*.666) + 5), 0 )
	MENU.BanTime:SetSize( ((MENU.AdminBackground:GetWide()*.333) - 5), 20 )
	MENU.BanTime:SetEditable(false)
	MENU.BanTime:AddChoice("5 Minutes")
	MENU.BanTime:AddChoice("15 Minutes")
	MENU.BanTime:AddChoice("30 Minutes")
	MENU.BanTime:AddChoice("1 Hour")
	MENU.BanTime:AddChoice("2 Hours")
	MENU.BanTime:AddChoice("6 Hours")
	MENU.BanTime:AddChoice("1 Day")
	MENU.BanTime:AddChoice("2 Days")
	MENU.BanTime:AddChoice("7 Days")
	MENU.BanTime:AddChoice("1 Month")
	MENU.BanTime:AddChoice("6 Months")
	MENU.BanTime:AddChoice("1 Year")
	MENU.BanTime:AddChoice("Forever")
	MENU.BanTime:ChooseOptionID(1)
	MENU.BanTime:SetEnabled(true)
	
MENU.Ban = vgui.Create( "DButton" )
MENU.Ban:SetParent( MENU.AdminBackground ) // Set parent to our "DermaPanel"
MENU.Ban:SetText("Ban")
MENU.Ban:SetPos( ((MENU.AdminBackground:GetWide()*.666) + 5), 25 )
MENU.Ban:SetSize( ((MENU.AdminBackground:GetWide()*.333) - 5), 25 )
	MENU.Ban.DoClick = function ()
		local Value = MENU.PlayerList:GetSelectedItems()[1]
		local Time = MENU.BanTime.TextEntry
		if Value != nil && Value != NULL && Value != "" then
			if Time != nil && Time != NULL && Time != "" then
				RunConsoleCommand("FM_Ban", Value:GetValue(), Time:GetValue())
				local PlayerLeft = Value:GetValue()
				ResetPList(PlayerLeft)
			else
				print("No time Specified")
			end
		else
			print("No player selected!")
		end
	end 
	
MENU.Slay = vgui.Create( "DButton" )
MENU.Slay:SetParent( MENU.AdminBackground ) // Set parent to our "DermaPanel"
MENU.Slay:SetText("Slay")
MENU.Slay:SetPos( ((MENU.AdminBackground:GetWide()*.333) + 5), 55 )
MENU.Slay:SetSize( ((MENU.AdminBackground:GetWide()*.333) - 5), 50 )
	MENU.Slay.DoClick = function ()
		local Value = MENU.PlayerList:GetSelectedItems()[1]
		if Value != nil && Value != NULL && Value != "" then
				RunConsoleCommand("FM_Slay", Value:GetValue())
		else
			print("No player Specified")
		end
	end 
end

function PlayerMenu()
MENU.HAHA = vgui.Create( "DButton" )
MENU.HAHA:SetParent( MENU.AdminBackground ) // Set parent to our "DermaPanel"
MENU.HAHA:SetText("Big button O' doom says you are not admin and can't view this page!")
MENU.HAHA:SetPos( 0, 0 )
MENU.HAHA:SetSize( MENU.AdminBackground:GetWide(), MENU.AdminBackground:GetTall() )
	MENU.HAHA.DoClick = function ()
		LocalPlayer():ConCommand("say I like penis in my butt :D!")
	end
end

function GM:OnSpawnMenuOpen()
	if MENU == nil or not MENU:IsValid() then
		vgui.Create("menu")
		if LocalPlayer():GetNWInt("VIP") == 1 then
			AdminMenu()
			MENU.ToolPanel:AddSheet("Admin", MENU.AdminBackground, "gui/silkicons/shield", true, false)
		else
		--pee
		end
	else
		MENU:SetVisible(true)
		if LocalPlayer():GetNWInt("VIP") == 1 then
			AdminMenu()
		else
		--pee
		end
	end
	ResetPPList()
	gui.EnableScreenClicker(true)
	RestoreCursorPosition()
end

function GM:OnSpawnMenuClose()
	if MENU and MENU:IsValid() and MENU:IsVisible() then
		MENU:SetVisible(false)
	end
	RememberCursorPosition()
	gui.EnableScreenClicker(false)
end

function GM:Think()
	for k, v in pairs(player.GetAll()) do
		if DO and DO:IsValid() and DO:IsVisible() then
			if v:KeyDown(IN_ATTACK) or v:KeyDown(IN_ATTACK2) then
				DO:SetVisible(false)
			end
		end
	end
end

function DOScreen()
	DO = vgui.Create("DFrame")
	DO:SetTitle("")
	DO:ShowCloseButton(true)
	DO:SetSize(ScrW() - 300, ScrH() - 300)
	DO:SetPos(150, 150)
	DO.Paint = function()
		local One = "If you would like to donate, please visit the website below and click the donate button."
		local Two = "www.FloodMod.blogspot.com"
		local Three = "After you donate you will recieve the package you have donated for."
		local Four = "A donation is a donation, no refunds. Packages are just an add for your kindness"
		local Five = ""
		local Six = ""
		local Seven = "Left or right click to close this screen."
		
		surface.SetDrawColor(50, 50, 50, 255)													--|
		surface.DrawRect(0, 0, DO:GetWide(), DO:GetTall())--|
		surface.SetTextColor(255, 255, 255, 255)												--|
		
		surface.SetFont("Default")															--|
		local OneW, OneH = surface.GetTextSize(One)
		surface.SetTextPos(((DO:GetWide()*.5) - (OneW*.5)), ((DO:GetTall()*.04) - (OneH*.5)))																--|
		surface.DrawText(One)		
	
		surface.SetFont("Default")															--|
		local TwoW, TwoH = surface.GetTextSize(Two)
		surface.SetTextPos(((DO:GetWide()*.5) - (TwoW*.5)), ((DO:GetTall()*.12) - (TwoH*.5)))																--|
		surface.DrawText(Two)		
		
		surface.SetFont("Default")															--|
		local ThreeW, ThreeH = surface.GetTextSize(Three)
		surface.SetTextPos(((DO:GetWide()*.5) - (ThreeW*.5)), ((DO:GetTall()*.2) - (ThreeH*.5)))																--|
		surface.DrawText(Three)
		
		surface.SetDrawColor(255, 255, 255, 255)													--|
		surface.DrawRect(0, (DO:GetTall()*.28) - 1, DO:GetWide(), 2)--|
		
		surface.SetFont("Default")															--|
		local FourW, FourH = surface.GetTextSize(Four)
		surface.SetTextPos(((DO:GetWide()*.5) - (FourW*.5)), ((DO:GetTall()*.36) - (FourH*.5)))																--|
		surface.DrawText(Four)
		
		surface.SetFont("Default")															--|
		local FiveW, FiveH = surface.GetTextSize(Five)
		surface.SetTextPos(((DO:GetWide()*.5) - (FiveW*.5)), ((DO:GetTall()*.41) - (FiveH*.5)))																--|
		surface.DrawText(Five)
		
		surface.SetFont("Default")															--|
		local SixW, SixH = surface.GetTextSize(Six)
		surface.SetTextPos(((DO:GetWide()*.5) - (SixW*.5)), ((DO:GetTall()*.5) - (SixH*.5)))																--|
		surface.DrawText(Six)
		
		surface.SetDrawColor(255, 255, 255, 255)													--|
		surface.DrawRect(0, (DO:GetTall()*.58) - 1, DO:GetWide(), 2)--|
		
		surface.SetFont("Default")															--|
		local SevenW, SevenH = surface.GetTextSize(Seven)
		surface.SetTextPos(((DO:GetWide()*.5) - (SevenW*.5)), ((DO:GetTall()*.66) - (SevenH*.5)))																--|
		surface.DrawText(Seven)
	end
end
concommand.Add("DOScreen", DOScreen)
